#ifndef OBJECTDOMAIN_H
#define OBJECTDOMAIN_H
#include <list>
#include <map>
#include <string>

/*
#include "../../_general/base/morfforward.h"
#include "../../_general/base/morfmodules.h"

#include "../implementation/testobject.h"
#include "../implementation/logindata.h"
#include "../implementation/chatdomain.h"
#include "../../_domain/base/objectman.h"
*/

#include <morfclasses.h>

#include "objectdomainactions.h"

namespace DOMAIN 
{
	class CObjectDomain : public CChatDomain
	{
	private:	
		NETWORK::CNetwork *network;
		sptr<CCharacterObject> controllingObj;
		sptr<CPhysicalLevelObject> cameraObj; 
		CObjectDomainActions *actionObj;

		NETWORK::PClientInfoList serverClientInfo;

	public:
		//CCharacterObject *camObj; 

		inline CObjectDomain() 
			: CChatDomain(false), cameraObj(NULL)
		{
			serverClientInfo = new NETWORK::TClientInfoList();
			actionObj=new CObjectDomainActions(*this);
		}
		virtual ~CObjectDomain();

		virtual void handleNetworkObject(sptr<GENERAL::CSerializeableObject> &so);
		virtual void updateObject(GENERAL::CBuffer &buffer, CGameObject *go, NETWORK::PClientInfoList from);
		virtual void HandleDomainCommand(sptr<DOMAIN::CDomainCommand> cmd);

		virtual CDomain::PObjectList GetVisibleObjects();

		inline sptr<CCharacterObject> &GetControllingObj() {return controllingObj;};
		inline sptr<CPhysicalLevelObject> &GetCameraObj() {return cameraObj;};
		inline CObjectDomainActions &GetActionObj() {return *actionObj;};

		virtual void help(char *command);
		virtual void Init();
		inline CSimpleObjectManager *GetObjMan() {return (CSimpleObjectManager*)objMan;}
		virtual void execute();

		
		
		friend class CObjectDomainActions;
	};



}

#endif