#include "CTL2Button.h"

namespace FRONTEND
{
	CCTL2Button::CCTL2Button(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2ClientWindow(_fe,_domainObj, _guiStyle, _userdata, _callback)
	{
		clientArea->ClearReceiveMouseMoveEvents();
		clientArea->ClearReceiveMouseButtonEvents();
		clientArea->ClearReceiveKeyEvents();
		SetNotMoveable();
		SetNotResizeable();
		styleElement = guiStyle->btndefault;
	}

	bool CCTL2Button::MouseEnter()
	{
		SetSubStyle(CResGUIStyle::EBUTTON_HIGHLIGHTED_RELEASED);
		return CCTL2ClientWindow::MouseEnter();
	}

	bool CCTL2Button::MouseLeave()
	{
		SetSubStyle(CResGUIStyle::EBUTTON_RELEASED);
		return CCTL2ClientWindow::MouseLeave();
	}
	bool CCTL2Button::MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		return CCTL2ClientWindow::MouseMove(x,y,z,buttons,keys);
	}

	bool CCTL2Button::MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		SetSubStyle(CResGUIStyle::EBUTTON_FOCUSED_PRESSED);
		SetMouseCapture();
		return CCTL2ClientWindow::MouseDown(button,x,y,z,buttons,keys);
	}

	bool CCTL2Button::MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		SetSubStyle(CResGUIStyle::EBUTTON_FOCUSED_RELEASED);
		ReleaseMouseCapture();
		return CCTL2ClientWindow::MouseUp(button,x,y,z,buttons,keys);
	}

	CCTL2TextButton::CCTL2TextButton(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Button(_fe,_domainObj,_guiStyle,_userdata,_callback),
		  caption(new CCTL2Label(_fe,_domainObj,_guiStyle,_userdata,_callback))
	{
		caption->ClearReceiveMouseMoveEvents();
		caption->ClearReceiveMouseButtonEvents();
		caption->ClearReceiveKeyEvents();
	}

	void CCTL2TextButton::Init(sptr<CRenderAble> &_self)
	{
		CCTL2Button::Init(_self);
		caption->SetAnchorTop();
		caption->SetAnchorLeft();
		caption->SetAnchorRight();
		caption->SetAnchorBottom();
		caption->SetAlignHCenter();
		caption->SetAlignVCenter();
		InsertControl((sptr<CCTL2Window>)caption);
		caption->SetPos(0,0,caption->GetParent()->GetPos().w,caption->GetParent()->GetPos().h);
	}


}