#ifndef CTL2BUTTON_H
#define CTL2BUTTON_H

#include "CTL2ClientWindow.h"
#include "CTL2Label.h"

namespace FRONTEND
{
	class CCTL2Button : public CCTL2ClientWindow
	{
	public:
		CCTL2Button(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		

		virtual bool MouseEnter();
		virtual bool MouseLeave();
		virtual bool MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);

	};

	class CCTL2TextButton : public CCTL2Button 
	{
	protected:
		sptr<CCTL2Label> caption;
	public:
		CCTL2TextButton(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual void Init(sptr<CRenderAble> &_self);

		inline sptr<CCTL2Label> &GetCaption() {return caption;}
	};
}

#endif