#ifndef CTL2CLIENTWINDOW_H
#define CTL2CLIENTWINDOW_H

#include "CTL2Container.h"

namespace FRONTEND
{
	class CCTL2ClientWindow : public CCTL2Container
	{
	public:
		struct TBorderSize{
			int l,t,r,b;

			inline TBorderSize() : l(0), t(0), r(0), b(0) {};
			inline TBorderSize(const TBorderSize &_bs) : l(_bs.l), t(_bs.t), r(_bs.r), b(_bs.b) {};
			inline TBorderSize(int _l, int _t, int _r, int _b) : l(_l), t(_t), r(_r), b(_b) {};
		};

	protected:
		virtual void SetClientSize();
		virtual void CalculateClientSize(TMorfRecti &rect);
		virtual void CalculateWindowSize(int &_cx, int &_cy); // _cx, _cy ... ClientSize;

		class CCTL2ClientArea : public CCTL2Container
		{
		public:
			CCTL2ClientArea(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);
			virtual void Resize(int w, int h);

			friend void CCTL2ClientWindow::SetClientSize();

		};

		TBorderSize borderSize;
		TSurface	borderSurfaces[8];

		sptr<CCTL2ClientArea> clientArea;

	public:
		CCTL2ClientWindow(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual ~CCTL2ClientWindow();
		virtual void Init(sptr<CRenderAble> &_self);
		virtual void SetStyleElement(CResGUIStyle::TElement *_styleElement);
		virtual void SetSubStyle(int _num);
		virtual void SetUserdata(void *_userdata);

		virtual void RenderScissor(TMorfRecti _scissor, int _dt);
		virtual void CalculateSurfaces();

		virtual void InsertControl(sptr<CCTL2Window> &_ctl);
		virtual void RemoveControl(CCTL2Window *_ctl);
		virtual void BringToFront(CCTL2Window *_ctl);
		virtual void SendToBack(CCTL2Window *_ctl);

		virtual CCTL2Container* GetClientArea() {return &clientArea;}
		virtual ECTL2ResizeArea GetResizeArea(int x,int y);
		inline SetBorderSize(int _l, int _t, int _r, int _b)
		{
			borderSize.l=_l;
			borderSize.t=_t;
			borderSize.r=_r;
			borderSize.b=_b;

			SetClientSize();
			CalculateSurfaces();
		}
		virtual void _Resize(int w, int h);
		virtual void ClientResized(int w, int h);
	};
}

#endif