#ifndef CTL2Container
#define CTL2Container

#include "CTL2Window.h"

namespace FRONTEND
{
	class CCTL2Container : public CCTL2Window
	{
	public:
		typedef std::deque<sptr<CCTL2Window> > TWindowList;

	protected:
		TWindowList children;
		TMorfPointi screenPos;
		TMorfPointi renderOfs;


		virtual void SetChildPos(int _osx, int _osy, int _nsx, int _nsy, CCTL2Window *_win);
	public:
		CCTL2Container(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual ~CCTL2Container();
		virtual void Init(sptr<CRenderAble> &_self);

		virtual void RenderScissor(TMorfRecti _scissor, int _dt);
		virtual void CalculateSurfaces();

		inline void SetRenderOfs(int x, int y)  {renderOfs.x=x; renderOfs.y=y; CalculateSurfaces();}
		virtual void _Resize(int w, int h);

		virtual void InsertControl(sptr<CCTL2Window> &_ctl);
		virtual void RemoveControl(CCTL2Window *_ctl);
		virtual void BringToFront(CCTL2Window *_ctl);
		virtual void SendToBack(CCTL2Window *_ctl);

		inline TMorfPointi &GetScreenPos() { return screenPos; };
		inline bool HasChild(CCTL2Window *_ctl)
			{
				TWindowList::iterator it = children.begin();
				while (it!=children.end())
					if (&(*it)==_ctl) return true;
				return false;
			}

		virtual bool MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
	};
}

#endif