#ifndef CTL2EDIT_H
#define CTL2EDIT_H

#include "CTL2Label.h"

namespace FRONTEND 
{
	class CCTL2Edit : public CCTL2Label
	{
	protected:
		int markStart,markEnd;

		virtual int GetCharAt(int x, int y);

		bool DeleteChar(int index);
		bool DeleteMark();
	public:
		CCTL2Edit(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual ~CCTL2Edit();
		virtual void Init(sptr<CRenderAble> &_self);

		virtual void CalculateSurfaces();
		virtual bool KeyDown(int key,TKeyStates &keystate);
		virtual bool KeyPress(int key,TKeyStates &keystate);
		virtual bool MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys);
		virtual void SetText(char *_text);
	};
}

#endif