#include "CTL2Icon.h"
#include "../implementation/glFE.h"

namespace FRONTEND
{
	CCTL2Icon::CCTL2Icon(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, char *_shaderName, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Window(_fe,_domainObj,_guiStyle,_userdata,_callback),
		  shaderName(strdup(_shaderName))
	{}

	CCTL2Icon::CCTL2Icon(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Window(_fe,_domainObj,_guiStyle,_userdata,_callback),
		  shaderName(strdup(_domainObj->GetIcon()))
	{}

	void CCTL2Icon::Init(sptr<CRenderAble> &_self)
	{
		CCTL2Window::Init(_self);

		HResShader sh = ((CGLFrontEnd*)fe)->GetResMan()->GetPtr((sptr<CRenderAble>)self, shaderName, RESTYP_SHADER);
		if (sh->GetShaderStatus()==CResShader::EShaderStatus::SS_NOTLOADED)
			sh->LoadDefaultShaderGUI(shaderName);

		SetShader(sh);
	}
}