#ifndef CTL2_SCROLLBAR_H
#define CTL2_SCROLLBAR_H

#include "CTL2ClientWindow.h"
#include "CTL2Button.h"

namespace FRONTEND
{
	class CCTL2ScrollBar : public CCTL2ClientWindow
	{
	public:
		enum EScrollBarType
		{
			SB_VERTICAL,
			SB_HORIZONTAL,
		};
	private:
		static bool StaticCallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,void *pparam, void *userdata);
		bool CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam);

	protected:
		sptr<CCTL2Button> btnLow, btnHigh;
		sptr<CCTL2ClientWindow> slider;
		EScrollBarType scrollBarType;

		int maxVal;
		int minVal;
		int pageSize;
		int scrollPos;

		virtual void SetSliderSize();
		virtual void SetSliderPos();
		virtual int CalculatePosFromSlider();

		virtual void _Resize(int w, int h);
	public:
		CCTL2ScrollBar(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, EScrollBarType _scrollBarType, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual void Init(sptr<CRenderAble> &_self);

		inline SetMaxVal(int _val) {maxVal=_val; SetSliderSize(); SetSliderPos(); }
		inline SetMinVal(int _val) {minVal=_val; SetSliderSize(); SetSliderPos(); }
		inline SetPageSize(int _val) {pageSize=_val; SetSliderSize(); SetSliderPos(); }
		inline SetScrollPos(int _val) {scrollPos=_val; SetSliderSize(); SetSliderPos(); }
		inline int GetScrollPos() {return scrollPos;}
		inline int GetMaxVal() {return maxVal; }
		inline int GetMinVal() {return minVal; }
		inline int GetPageSize() {return pageSize; }

	};
}

#endif