#include "DLG2ActionPopUp.h"

namespace FRONTEND
{
	CDLG2ActionPopUp::CDLG2ActionPopUp(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, DOMAIN::CGameObject::tActionList &_actionMask, void *_userdata, FCTL2CallBack _callback)
		: CCTL2ClientWindow(_fe, _domainObj, _guiStyle,_userdata,_callback),
		  actionMask(_actionMask)
	{
	}

	void CDLG2ActionPopUp::Init(sptr<CRenderAble> &_self)
	{
		CCTL2ClientWindow::Init(_self);		
		
		DOMAIN::CGameObject::tActionList::reverse_iterator it;
		DOMAIN::CGameObject::tActionList actions;
		domainObj->GetActionList(actions);
		actions = actions & actionMask;

		SetStyleElement(guiStyle->window);

		int y=0;

		for (it=actions.rbegin(); it!=actions.rend(); it++)
		{
			sptr<CCTL2TextButton> button(new CCTL2TextButton((CFrontEnd*)fe,domainObj,guiStyle,this,StaticCallBack));

			buttons.push_back(button);
			button->SetStyleElement(guiStyle->btnpopup);
			button->SetSubStyle(0);
			button->Init((sptr<CRenderAble>)button);
			button->GetCaption()->SetText((char*)CONFIG::g_config.ObjectActionsCaptions[*it].data());
			button->GetCaption()->SetAlignHLeft();
			button->GetClientArea()->Resize(100,button->GetClientArea()->GetShader()->fnt->GetHeight());
			button->Move(0,y);
			button->SetAnchorBottom();
			button->ClearAnchorTop();
			button->SetCTLID(~(*it));
			InsertControl((sptr<CCTL2Window>)button);
			y+=button->GetPos().h;
		}

		if (!buttons.empty())
			clientArea->Resize(buttons[0]->GetPos().w,(int)actions.size()*buttons[0]->GetPos().h);
		else
			clientArea->Resize(100,1);

		SetClientSize();
	}

	bool CDLG2ActionPopUp::StaticCallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,void *pparam, void *userdata)
	{
		if (userdata!=NULL)
			return ((CDLG2ActionPopUp*)userdata)->CallBack(ctl,action,lparam,(TCTL2PParam*)pparam);
		else
			return DummyCallBack(ctl,action,lparam,pparam,userdata);
	}

	bool CDLG2ActionPopUp::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		switch (action)
		{
		case CB2ACTION_MOUSECLICK:
			Hide();
			return callBack(this,CB2ACTION_MOUSECLICK,~(ctl->GetCTLID()),pparam,userdata);
			break;
		}

		return DummyCallBack(ctl,action,lparam,pparam,this);
	}
}