#include "DLG2ChatWindow.h"

#include "../implementation/glfe.h"

namespace FRONTEND
{
	CDLG2ChatWindow::CDLG2ChatWindow(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Dialog(_fe, _domainObj, _guiStyle,_userdata,_callback),
		slBody(new CCTL2StringList(_fe,NULL,_guiStyle,NULL,StaticCallBack)),
		eInput(new CCTL2Edit(_fe,NULL,_guiStyle,NULL,StaticCallBack))
	{
		//lines = new CCTL2StringList::TLineList;
	}

	void CDLG2ChatWindow::Init(sptr<CRenderAble> &_self)
	{
		CCTL2Dialog::Init(_self);
		SetScrollAreaAutoSizeX();
		SetScrollAreaAutoSizeY();

		vScrollBar->Hide();
		hScrollBar->Hide();
		clientArea->Resize(150,220);
		titleLabel->SetText("ChatWindow");

		eInput->SetUserdata(this);
		eInput->Init((sptr<CRenderAble>)eInput);
		InsertControl((sptr<CCTL2Window>)eInput);
		eInput->ClearAnchorTop();
		eInput->SetAnchorBottom();
		eInput->SetAnchorLeft();
		eInput->SetAnchorRight();
		eInput->ClearMultiLine();
		eInput->ClearWordWrap();
		eInput->SetPos(0,0,eInput->GetParent()->GetPos().w,GetShader()->fnt->GetHeight());
		eInput->SetNotMoveable();
		eInput->SetNotResizeable();

		slBody->SetUserdata(this);
		slBody->Init((sptr<CRenderAble>)slBody);
		InsertControl((sptr<CCTL2Window>)slBody);
		slBody->SetUseLines(&lines);
		slBody->SetAnchorTop();
		slBody->SetAnchorBottom();
		slBody->SetAnchorLeft();
		slBody->SetAnchorRight();
		slBody->SetPos(0,GetShader()->fnt->GetHeight(),eInput->GetParent()->GetPos().w,slBody->GetParent()->GetPos().h-GetShader()->fnt->GetHeight());
		slBody->SetNotMoveable();
		slBody->SetNotResizeable();
		slBody->SetBorderSize(0,0,0,2);

		SetPos(100,100,150,220);
		SetClientSize();

		Resize(150,100);

		domainObj->AddUpdateRenderable(this);
	}

	bool CDLG2ChatWindow::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		if (ctl==&eInput)
		{
			if (action==CB2ACTION_KEYPRESS)
			{
				if (lparam=='\r')
				{

					sptr<DOMAIN::CGraphObject> go = ((CGLFrontEnd*)fe)->GetDomain()->GetControllingObj();
					
					//sptr<DOMAIN::CGraphObject> cc = (DOMAIN::CChatChannel*)domainObj;
					DOMAIN::CGraphObject *cc = (DOMAIN::CChatChannel*)domainObj;

					long ccid = ((DOMAIN::CChatChannel*)domainObj)->GetID();
					go->ExecuteAction(101,cc,ccid,(void*) eInput->GetText()); // 0 means the controlling object
					eInput->SetText("");
					return true;
				}
			}
		}
		return CCTL2Dialog::CallBack(ctl,action,lparam,pparam);
	}

	void CDLG2ChatWindow::Update(int _flags)
	{
		AppendText(((DOMAIN::CChatChannel*)domainObj)->GetLastText());
	}

	void CDLG2ChatWindow::AppendText(char *text)
	{
		slBody->InsertLine(text,-1);
	}

}