#include "DLG2FSMInfo.h"

namespace FRONTEND
{
	CDLG2FSMInfo::CDLG2FSMInfo(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Dialog(_fe, _domainObj, _guiStyle,_userdata,_callback),
		 
		  info(new CCTL2StringList(_fe,NULL,_guiStyle,NULL))
	{
		 sets[0] = new CCTL2Label(_fe,NULL,_guiStyle,NULL);
		 sets[1] = new CCTL2Label(_fe,NULL,_guiStyle,NULL);
		 sets[2] = new CCTL2Label(_fe,NULL,_guiStyle,NULL);


	}

	void CDLG2FSMInfo::Init(sptr<CRenderAble> &_self)
	{
		CCTL2Dialog::Init(_self);
		SetScrollAreaAutoSizeX();
		SetScrollAreaAutoSizeY();

		vScrollBar->Hide();
		hScrollBar->Hide();
		clientArea->Resize(150,5*GetShader()->fnt->GetHeight());
		titleLabel->SetText((char*)domainObj->GetCaption());

		for (int i=0; i<3; i++)
		{
			sets[i]->Init((sptr<CRenderAble>)sets[i]);
			sets[i]->ClearMultiLine();
			sets[i]->ClearWordWrap();
			sets[i]->SetAlignHLeft();
			sets[i]->SetAlignVCenter();
			sets[i]->SetAnchorTop();
			sets[i]->SetAnchorLeft();
			sets[i]->SetAnchorRight();
			sets[i]->ClearAnchorBottom();	
			sets[i]->SetPos(0,(4-i)*GetShader()->fnt->GetHeight(),clientArea->GetPos().w,GetShader()->fnt->GetHeight());
			InsertControl((sptr<CCTL2Window>)sets[i]);
		}

		//sets[3]->SetText((char*)domainObj->GetCaption());

		domainObj->AddUpdateRenderable(this);
		domainObj->UpdateRenderables(FRONTEND::UPDATEFLAGS_ALL);



	}

	bool CDLG2FSMInfo::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		return CCTL2Dialog::CallBack(ctl,action,lparam,pparam);
	}

	void CDLG2FSMInfo::Update(int _flags)
	{

		std::vector<std::string> lines = domainObj->GetFSM()->GetCurrentStates();
		if (lines.size()>0) sets[0]->SetText((char*)lines[0].data());
			else sets[0]->SetText("no set");
		if (lines.size()>1) sets[1]->SetText((char*)lines[1].data()); 
			else sets[1]->SetText("no set");
		if (lines.size()>2) sets[2]->SetText((char*)lines[2].data());
			else sets[2]->SetText("no set");
	}

}