#ifndef CAMERA_H
#define CAMERA_H

//#include <morfbase.h>
#include <morfclasses.h>

#include <morftypes.h>
#include <glheaders.h>



//#include "../../

namespace FRONTEND
{
	class CFrustum
	{
		enum {
			PLANE_RIGHT  = 0,
			PLANE_LEFT   = 1,
			PLANE_BOTTOM = 2,
			PLANE_TOP    = 3,
			PLANE_FAR    = 4,
			PLANE_NEAR   = 5};

	protected:
		GENERAL::CPlanef planes[6];

	public:
		inline CFrustum() {};
		virtual ~CFrustum();

		void CalculateFrustum(GENERAL::CMatrix4f &proj,GENERAL::CMatrix4f &model);

		bool IsPointInside(GENERAL::CVector3f &point);
		bool IsBoxInside(GENERAL::CVector3f &min,GENERAL::CVector3f &max);

		
	};

	class CCamera
	{
	protected:
		CFrustum frustum;
		sptr<DOMAIN::CWorldObject> attached;

		sptr<DOMAIN::CPhysicalLevelObject> levelobj;

		bool lvlda;
		
	public:
		CCamera();
		virtual ~CCamera();
		
		virtual void Look();

		inline GENERAL::CVector3f &GetView() { return attached->GetRotation(); };
		inline GENERAL::CVector3f &GetPos() {return cpos;};
		inline CFrustum &GetFrustum() {return frustum;};

		
		DOMAIN::CQuakeBsp *level;
		GENERAL::CVector3f cpos;

		inline sptr<DOMAIN::CWorldObject> &GetAttached() { return attached; };
		inline void Attach(sptr<DOMAIN::CWorldObject> _o) 
		{ 
			attached = _o; 

			lvlda = true;
			levelobj->SetLvl(((DOMAIN::CPhysicalLevelObject*)&_o)->GetLvl());
		
		};


	};
}

#endif