
#include "resman.h"
#include <trace.h>


namespace FRONTEND
{
	
	CResManagerGL::~CResManagerGL()
	{
		TNameToPtrMap::iterator it;

		while (!resMap.empty())
		{
			bool deleted=false;
			for (it = resMap.begin(); it!=resMap.end(); it++)
			{
				if (it->second.GetRefCount()==1)
				{
					resMap.erase(it);
					deleted=true;
					break;
				}
			}
			if (!deleted)
//				break;
				resMap.clear();
		}

/*		while (!resMap.empty())
		{
			it = resMap.begin();
			CFEResource *rp;
			{
				HFEResource r1,r=it->second;
				r1=r;
				r.ForceDelete();
				rp = &r;
			}
			resMap.erase(it);
		}*/

		resMap.clear();
/*		for (it=resMap.begin(); it!=resMap.end(); it++)
		{
			delete it->second;
		}*/

	};

	HFEResource CResManagerGL::GetPtr(sptr<CRenderAble> &_renderable, char *_resName, EResTyp _typ)
	{
		TNameToPtrMap::iterator it = resMap.find(_resName);
		if (it==resMap.end())
		{
			HFEResource res = CreateRes(_resName, _typ);
			res->AddRenderableRef(_renderable);
			return res;
		}
		else 
		{
			if (it->second->GetStatus()>=RESSTATUS_INMEMORY)
			{
				if (_renderable!=NULL)
					_renderable->ResourceLoaded(&it->second);
			} else {
				it->second->AddRenderableRef(_renderable);
			}
			return it->second;
		}
	}

	HFEResource CResManagerGL::CreateRes(char *_resName, EResTyp _typ)
	{
		HFEResource newRes = 0;

		if (_typ==RESTYP_AUTO)
		{

			if (strstr(_resName, ".tga") || strstr(_resName, ".TGA"))
			{
				newRes = new CResTextureGL(this, _resName, RESSTATUS_ONLYINGA);
				// should catch not yet implemetated exception if loading failed
			}
			if (strstr(_resName, ".bmp") || strstr(_resName, ".BMP"))
			{
				newRes = new CResTextureGL(this, _resName, RESSTATUS_ONLYINGA);
				// should catch not yet implemetated exception if loading failed
			}

		}
		else
		{
			switch (_typ)
			{
			case RESTYP_TEXTURE: newRes =	HFEResource(new CResTextureGL(this, _resName, RESSTATUS_ONLYINGA)); break;
			case RESTYP_TTFONT: newRes =	HFEResource(new CResTTFontGL  (this, _resName, 14, RESSTATUS_ONLYINGA)); break;
			case RESTYP_BMPFONT: newRes =	HFEResource(new CResBMPFontGL  (this, _resName, RESSTATUS_ONLYINGA)); break;
			case RESTYP_SHADER: newRes =	HFEResource(new CResShaderGL(this, _resName, RESSTATUS_INMEMORYANDGA)); break;
			case RESTYP_MD3LINK: newRes =	HFEResource(new CResMD3Link(this, _resName, RESSTATUS_INMEMORY)); break;
			case RESTYP_FSM: newRes =		HFEResource(new CResFSM(this,_resName, RESSTATUS_INMEMORY)); break;
			case RESTYP_GUISTYLE: newRes =	HFEResource(new CResGUIStyle(this,_resName, RESSTATUS_INMEMORY)); break;
			}
		}
        
		if (newRes!=0) resMap[_resName]=newRes;

		return newRes;

	}
}
