#ifndef FE_OBJECT_MD3OBJECT
#define FE_OBJECT_MD3OBJECT

#include <morfclasses.h>
#include "../resources/md3link.h"
#include "../implementation/surface.h"
#include "../implementation/renderer.h"
#include "fmod.h"

namespace FRONTEND
{
	class CMD3Object : public CRenderAble
	{
	public:
		enum EMD3FECommand {
			MD3SELECT, 
			MD3DESELECT
		};

		
		TShadowSource *shadowSource;
		bool shadowCaster;
		bool shadowReceiver;
	protected:

		// ??? wie macht ma des am gscheitesten
		//void LoadModelTextures(GENERAL::tMD3Model *pModel, char *strPath);

		DOMAIN::CMD3Object::tLinkMap &domainLinkMap;
		char *filename;

		int linkedAtTagID;
		GENERAL::UBYTE recFlag; // &0.. rendered, &1..updated
		HResMD3Link link;
		TSurface *pSurfaces;
		TSurfaceStructure *pSurfaceStructures;
		CMatrix4f modelView;

		long currentAnimName;
		int currentAnim;					
		int currentFrame;					
		int nextFrame;	
		float animt;
		float framet;   // wie weit bin ich in der animatqion

		void UpdateAnimation(float _dt);
		long ExecuteCommand(long cmd);
		
		FSOUND_STREAM *sound;
		int soundChannel;	
		int oldLink;

	public:

		CMD3Object(void *_fe, DOMAIN::CGraphObject *_domainObj, char *_filename);
		virtual void Init(sptr<CRenderAble> &_self);

		virtual ~CMD3Object();

		virtual void Update(int _flags = UPDATEFLAGS_ALL);
		virtual void Render(int _dt = 0);
		virtual void RenderRecursive(int _dt, DOMAIN::CMD3Object::tLinkMap &_linkMap);
		virtual void ClearRecFlags(DOMAIN::CMD3Object::tLinkMap &_linkMap);

		virtual void ResourceLoaded(CFEResource *_res);

		virtual bool MouseDown(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys);
		inline int TranslateAnimName(long _name)
		{
			if (_name<=13)
				return _name-1;
			return _name-8;
		}
		inline void SetLinkedAtTagID(long _tagID) 
		{
			linkedAtTagID=_tagID;

			switch (linkedAtTagID)
			{
//			case 1:	currentAnim=15; break;
//			case 4:	currentAnim=11; break;
//			case 1:	currentAnim=8; break;
//			case 4:	currentAnim=11; break;
			case 1: currentAnimName=1; 
					currentAnim=0; break;
			case 4:	currentAnimName=1;
					currentAnim=0; break;

			default: currentAnim=-1;
			}
		};

		void PropagateStateCommand(int _cmd, DOMAIN::CMD3Object::tLinkMap &_linkMap);
		void PropagateFECommand(EMD3FECommand _cmd, DOMAIN::CMD3Object::tLinkMap &_linkMap);
		void ExecuteFECommand(EMD3FECommand _cmd);
		virtual void Select();
		virtual void Deselect();


		inline long GetLinkedAtTagID() {return linkedAtTagID;};
		inline void SetLinkMap(DOMAIN::CMD3Object::tLinkMap &_domainLinkMap) {domainLinkMap = _domainLinkMap;}

	};
}

#endif
