#ifndef FEOBJECT_QUAKEBSP_H
#define FEOBJECT_QUAKEBSP_H

#include <morfclasses.h>
#include "../resources/shader.h"
#include "../implementation/surface.h"
//#include "../implementation/camera.h"

namespace FRONTEND
{
	class CGLFrontEnd;

	class CObjQuakeBsp : public CRenderAble
	{
	public:
		struct TPatch
		{
			typedef GENERAL::TBiQuadricBezierPatch<GENERAL::SCALAR,GENERAL::tBSPVertex> TBiQaudricBezier;

			int sizeu,sizev;
			int numOfVerts;
			GENERAL::tBSPVertex *vertices;
			int numOfIndices;
			int *indices;
		};

	protected:

		HResShader *shaders;
		CResourceManager *resMan;
		TSurface *surfaces;

		int m_numOfVerts;			
		int m_numOfFaces;	
		int m_numOfPatches;
		int m_numOfLightmaps;		
		int m_numOfMeshIndices;
		int m_numOfShaders;


		GENERAL::tBSPVertex		*m_pVerts;	
		GENERAL::tBSPFace		*m_pFaces;		
		GENERAL::tBSPLightmap	*m_pLightmaps;
		int						*m_pMeshIndices;
		GENERAL::tBSPShader		*m_pShaders;
		TPatch					*m_pPatches;

		inline DOMAIN::CQuakeBsp *GetBsp() { return (DOMAIN::CQuakeBsp*) domainObj;};
		void LoadDataFromFile();
		void Tesselate(int tesselFactor);


	public:

		CObjQuakeBsp(void *_fe, CResourceManager *_resMan, DOMAIN::CQuakeBsp *_bsp);
		virtual ~CObjQuakeBsp();
	};


	class CObjQuakeBspGL : public CObjQuakeBsp
	{
		protected:
			int faces_renderd;
			bool *pFaceRendered;
			bool *pClusterRendered;
			CResTextureGL **pLightMaps;

			void RenderFace(GENERAL::tBSPFace &face);
			void RenderLeaf(GENERAL::tBSPLeaf &leaf, int _dt);

			int FindLeaf(GENERAL::CVector3f &pos);

			void ChangeGamma(float factor, GLubyte *pImage);

		public:

			CObjQuakeBspGL(CGLFrontEnd *_fe, CResManagerGL *_resMan, DOMAIN::CQuakeBsp *_bsp);

			virtual ~CObjQuakeBspGL();

			virtual void Render(int _dt = 0);
			virtual bool MouseDown(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys);
			virtual void RenderLeafBrushes(CVector3f &pos);
	};

}

#endif