#include "guistyle.h"

namespace FRONTEND
{
	CResGUIStyle::CResGUIStyle(CResourceManager *_resMan,char *_file, int _targetstatus)
		: CFEResource(_resMan,_file,_targetstatus)

	{
/*		memset(window,0,sizeof(window));
		memset(titlebar,0,sizeof(titlebar));
		memset(btndefault,0,sizeof(btndefault));
		memset(btnup,0,sizeof(btnup));
		memset(btndown,0,sizeof(btndown));
		memset(btnleft,0,sizeof(btnleft));
		memset(btnright,0,sizeof(btnright));
		memset(btnminimize,0,sizeof(btnminimize));
		memset(btnclose,0,sizeof(btnclose));
		memset(btnmaximize,0,sizeof(btnmaximize));
		memset(btnpopup,0,sizeof(btnpopup));*/

		LoadFromFile(_file,_targetstatus);
	}

	CResGUIStyle::~CResGUIStyle()
	{}
		
	bool CResGUIStyle::LoadFromFile(char *_file, int _targetstatus)
	{
		FILE *f = GENERAL::morfOpenFile(_file,"r");
		if (f==NULL)
			return false;

		char line[1024];
		int incr;
		while (fgets(line,1024,f)!=NULL)
		{
			char *comment = strstr(line,"//");
			if (comment!=NULL)
				*comment='\0';

			char *token = strtok(line," \t\n");
			if (token==NULL)
				continue;

			char *nparam = strstr(token,":");
			incr=0;

			if (nparam!=NULL)
			{
				*nparam='\0';
				nparam++;

				if (!stricmp(nparam,"r"))
					incr=EBUTTON_RELEASED;
				else if (!stricmp(nparam,"fr"))
					incr=EBUTTON_FOCUSED_RELEASED;
				else if (!stricmp(nparam,"hr"))
					incr=EBUTTON_HIGHLIGHTED_RELEASED;
				else if (!stricmp(nparam,"fp"))
					incr=EBUTTON_FOCUSED_PRESSED;
			}

			char *elementdata = strtok(NULL,"");
			if (elementdata==NULL)
				continue;

			if (!stricmp(token,"window"))
			{
				ParseElement(window,elementdata);
			} else if (!stricmp(token,"titlebar"))
			{
				ParseElement(titlebar,elementdata);
			} else if (!stricmp(token,"solidbckg"))
			{
				ParseElement(solidBckg,elementdata);
			} else if (!stricmp(token,"button"))
			{
				ParseElement(btndefault+incr,elementdata);
			} else if (!stricmp(token,"buttonup"))
			{
				ParseElement(btnup+incr,elementdata);
			} else if (!stricmp(token,"buttondown"))
			{
				ParseElement(btndown+incr,elementdata);
			} else if (!stricmp(token,"buttonleft"))
			{
				ParseElement(btnleft+incr,elementdata);
			} else if (!stricmp(token,"buttonright"))
			{
				ParseElement(btnright+incr,elementdata);
			} else if (!stricmp(token,"buttonminimize"))
			{
				ParseElement(btnminimize+incr,elementdata);
			} else if (!stricmp(token,"buttonmaximize"))
			{
				ParseElement(btnmaximize+incr,elementdata);
			} else if (!stricmp(token,"buttonclose"))
			{
				ParseElement(btnclose+incr,elementdata);
			} else if (!stricmp(token,"buttonpopup"))
			{
				ParseElement(btnpopup+incr,elementdata);
			}
		}

		if (ferror(f)!=0)
		{
			fclose(f);
			return false;
		}
		fclose(f);

		if (!titlebar->clientShader)
			titlebar->clientShader=window->clientShader;
		if (!titlebar->borderShader)
			titlebar->borderShader=window->borderShader;
		if (!titlebar->clientShader->fnt)
			titlebar->clientShader->fnt = window->clientShader->fnt;

		for (int i=0; i<EBUTTON_MAX; i++)
		{
			if (!btndefault[i].clientShader)
				btndefault[i].clientShader=window->clientShader;
			if (!btndefault[i].borderShader)
				btndefault[i].borderShader=window->borderShader;
			if (!btndefault[i].clientShader->fnt)
			{
				btndefault[i].clientShader->fnt = window->clientShader->fnt;
				btndefault[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btnup[i].clientShader)
				btnup[i].clientShader=window->clientShader;
			if (!btnup[i].borderShader)
				btnup[i].borderShader=window->borderShader;
			if (!btnup[i].clientShader->fnt)
			{
				btnup[i].clientShader->fnt = window->clientShader->fnt;
				btnup[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btndown[i].clientShader)
				btndown[i].clientShader=window->clientShader;
			if (!btndown[i].borderShader)
				btndown[i].borderShader=window->borderShader;
			if (!btndown[i].clientShader->fnt)
			{
				btndown[i].clientShader->fnt = window->clientShader->fnt;
				btndown[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btnleft[i].clientShader)
				btnleft[i].clientShader=window->clientShader;
			if (!btnleft[i].borderShader)
				btnleft[i].borderShader=window->borderShader;
			if (!btnleft[i].clientShader->fnt)
			{
				btnleft[i].clientShader->fnt = window->clientShader->fnt;
				btnleft[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btnright[i].clientShader)
				btnright[i].clientShader=window->clientShader;
			if (!btnright[i].borderShader)
				btnright[i].borderShader=window->borderShader;
			if (!btnright[i].clientShader->fnt)
			{
				btnright[i].clientShader->fnt = window->clientShader->fnt;
				btnright[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btnminimize[i].clientShader)
				btnminimize[i].clientShader=window->clientShader;
			if (!btnminimize[i].borderShader)
				btnminimize[i].borderShader=window->borderShader;
			if (!btnminimize[i].clientShader->fnt)
			{
				btnminimize[i].clientShader->fnt = window->clientShader->fnt;
				btnminimize[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btnmaximize[i].clientShader)
				btnmaximize[i].clientShader=window->clientShader;
			if (!btnmaximize[i].borderShader)
				btnmaximize[i].borderShader=window->borderShader;
			if (!btnmaximize[i].clientShader->fnt)
			{
				btnmaximize[i].clientShader->fnt = window->clientShader->fnt;
				btnmaximize[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btnclose[i].clientShader)
				btnclose[i].clientShader=window->clientShader;
			if (!btnclose[i].borderShader)
				btnclose[i].borderShader=window->borderShader;
			if (!btnclose[i].clientShader->fnt)
			{
				btnclose[i].clientShader->fnt = window->clientShader->fnt;
				btnclose[i].clientShader->fntColor = window->clientShader->fntColor;
			}

			if (!btnpopup[i].clientShader)
				btnpopup[i].clientShader=window->clientShader;
			if (!btnpopup[i].borderShader)
				btnpopup[i].borderShader=window->borderShader;
			if (!btnpopup[i].clientShader->fnt)
			{
				btnpopup[i].clientShader->fnt = window->clientShader->fnt;
				btnpopup[i].clientShader->fntColor = window->clientShader->fntColor;
			}
		}

		return false;
	}

	void CResGUIStyle::ParseElement(TElement *el, char *line)
	{
		char *token;
		char *clientshader;
		char *bordershader;
		char *eptr;

		// clientShader
		clientshader = strtok(line," \t\n");
		if (clientshader==NULL)
			return;

		// borderShader
		bordershader = strtok(NULL," \t\n");
		if (bordershader==NULL)
			return;

		// size X
		token = strtok(NULL," \t\n");
		if (token==NULL)
			return;
		el->sizex = strtol(token,&eptr,0);
		if ((eptr==token) || (*eptr!='\0'))
			return;

		// size Y
		token = strtok(NULL," \t\n");
		if (token==NULL)
			return;
		el->sizey = strtol(token,&eptr,0);
		if ((eptr==token) || (*eptr!='\0'))
			return;	
	
		// border Left
		token = strtok(NULL," \t\n");
		if (token==NULL)
			return;
		el->borderLeft = strtol(token,&eptr,0);
		if ((eptr==token) || (*eptr!='\0'))
			return;	

		// border Top
		token = strtok(NULL," \t\n");
		if (token==NULL)
			return;
		el->borderTop = strtol(token,&eptr,0);
		if ((eptr==token) || (*eptr!='\0'))
			return;	

		// border Right
		token = strtok(NULL," \t\n");
		if (token==NULL)
			return;
		el->borderRight = strtol(token,&eptr,0);
		if ((eptr==token) || (*eptr!='\0'))
			return;	

		// border Bottom
		token = strtok(NULL," \t\n");
		if (token==NULL)
			return;
		el->borderBottom = strtol(token,&eptr,0);
		if ((eptr==token) || (*eptr!='\0'))
			return;	

		el->sizex-=el->borderLeft+el->borderRight;
		el->sizey-=el->borderTop+el->borderBottom;

		el->clientShader = resMan->GetPtr(sptr<CRenderAble>(),clientshader,RESTYP_SHADER);
		el->borderShader = resMan->GetPtr(sptr<CRenderAble>(),bordershader,RESTYP_SHADER);
	}


	bool CResGUIStyle::LoadIntoGraphicAdapter(int _targetsatus)
	{
		return false;
	}

	bool CResGUIStyle::UnloadFromGraphicAdapter()
	{
		return false;
	}

}
