

#include "../../general/base/morfforward.h"
#include "application.h"

//#include "../../_domain/implementation/logindata.h"
//#include "../../_domain/implementation/chatdomain.h"

#include "../../general/base/tree.h"
#include "../../general/base/trace.h"

namespace APPLICATION
{

CApplication *CApplication::app;


CApplication::~CApplication()
{}

FRONTEND::CFrontEnd *CApplication::GetFE()
{
	return NULL;
}


void CApplication::RegisterClasses()
{
	
}

bool CApplication::Init()
{
	RegisterClasses();
	return true;
}

int CApplication::Run()
{
	while (!domain->ShouldTerminate())
		ExecuteSlice();

	return 0;
}


CWinApplication::~CWinApplication()
{
}

bool CWinApplication::Init()
{
	return CApplication::Init();
}

LRESULT CALLBACK CWinApplication::staticWindowProcedure(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
// never reached
	return 0;
//	return ((CWinApplication*)CApplication::GetApplication())->WindowProcedure(hWnd,uMsg,wParam,lParam);
}

void CWinApplication::ExecuteSlice()
{
	static int frames=0;
	static char line[256];
	MSG msg;
	if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	{
		TranslateMessage(&msg);
		GetNetwork()->Lock();
		DispatchMessage(&msg);
		GetNetwork()->Unlock();
	} else {
		try {
			GetNetwork()->Lock();
			GetDomain()->execute();
			frames++;

//			sprintf(line,"frames: %d",frames);
//			GetWorld()->GetConsoleData()->currentLine=line;
//			GetFrontend()->Render();

			GetNetwork()->Unlock();
		}
		catch (exception & e)
		{
			MessageBoxA(NULL,e.what(),"exception",MB_OK);
			GetDomain()->Terminate();
		}
	}
}

appexception::appexception(TErrorTyp _typ, LPCSTR szMessage)
	: exception(szMessage), __typ(_typ)
{}

appexception::appexception(LPCSTR szMessage)
	: exception(szMessage), __typ(appexception::TErrorTyp::ERR_UNKNOWN)
{}

appexception::appexception()
	: exception(), __typ(appexception::TErrorTyp::ERR_UNKNOWN)
{}


}