#include "loadingthread.h"
#include "application.h"

#include <windows.h>
#include <process.h>



namespace APPLICATION
{
	CLoadingQueuesItem::~CLoadingQueuesItem() {}

	CLoadingQueuesItemResource::~CLoadingQueuesItemResource()
	{
		free(file);
	}

	bool CLoadingQueuesItemResource::Load()
	{
		bool result =  res->LoadFromFile(file,FRONTEND::RESSTATUS_INMEMORY);

		WaitForSingleObject(loadingThread->mutex,INFINITE);
		loadingThread->loadedResources.push(this);
		ReleaseMutex(loadingThread->mutex);
		
		return result;
	}

	char *CLoadingQueuesItemResource::GetStatusString()
	{
		return statusString;
	}

	bool CLoadingQueuesItemGameObject::Load()
	{
		
		go->Load();
/*		((DOMAIN::CGraphObject*)go)->SetfeData(
			APPLICATION::CApplication::GetApplication()->GetFE()->CreateObject((DOMAIN::CGraphObject*)go,0));*/
		delete this;
		return true;
	}

	char *CLoadingQueuesItemGameObject::GetStatusString()
	{
		return statusString;
	}



	CLoadingThread::CLoadingThread()
	{
		mutex = CreateMutex(NULL,FALSE,NULL);
		semaphore = CreateSemaphore(NULL,0,10000,NULL);
		exitThread = false;
		loading = false;

		thread = (HANDLE)_beginthread((void (*)(void*))staticThread,0,this);
		statusString = 0;
	}

	CLoadingThread::~CLoadingThread()
	{
		WaitForSingleObject(mutex,INFINITE);
		exitThread = true;
		ReleaseMutex(mutex);
		ReleaseSemaphore(semaphore,1,NULL);

		WaitForSingleObject(thread,60000);

		while (!loadedResources.empty())
		{
			delete loadedResources.front();
			loadedResources.pop();
		}

		CloseHandle(mutex);
		CloseHandle(semaphore);
	}

	void CLoadingThread::staticThread(CLoadingThread *obj)
	{
		obj->loadingThread();
	}

	void CLoadingThread::loadingThread()
	{
		while (1)
		{
			WaitForSingleObject(semaphore,INFINITE);
			if (exitThread)
				_endthread();

			CLoadingQueuesItem *qi;
			WaitForSingleObject(mutex,INFINITE);
			qi = loadingQueues.front();

			statusString = qi->GetStatusString();

			loadingQueues.pop();
			ReleaseMutex(mutex);

			qi->Load();

			WaitForSingleObject(mutex,INFINITE);
			loading = !loadingQueues.empty();
			if (loadingQueues.empty()) statusString = 0;

			ReleaseMutex(mutex);
		}
	}

	bool CLoadingThread::IsLoading()
	{
		return loading;
	}

	void CLoadingThread::LoadResource(FRONTEND::CFEResource *_res, char *_file, int _targetstatus)
	{
		CLoadingQueuesItemResource *qi = new CLoadingQueuesItemResource(this, _res,_file,_targetstatus);
		WaitForSingleObject(mutex,INFINITE);
		loading = true;
		loadingQueues.push(qi);
		ReleaseMutex(mutex);
		ReleaseSemaphore(semaphore,1,NULL);
	}

	void CLoadingThread::LoadGameObject(DOMAIN::CGameObject *_go)
	{
		CLoadingQueuesItemGameObject *qi = new CLoadingQueuesItemGameObject(_go);
		WaitForSingleObject(mutex,INFINITE);
		loading = true;
		loadingQueues.push(qi);
		ReleaseMutex(mutex);
		ReleaseSemaphore(semaphore,1,NULL);
	}

	int CLoadingThread::GetQueuesSize()
	{
		int res;
		WaitForSingleObject(mutex,INFINITE);
		res = (int)loadingQueues.size();
		ReleaseMutex(mutex);
		return res;
	}

	void CLoadingThread::GetLoadedResources(TLoadedResources &_loadedResources)
	{
		WaitForSingleObject(mutex,INFINITE);
		_loadedResources=loadedResources;
		while (!loadedResources.empty())
			loadedResources.pop();
		ReleaseMutex(mutex);
	}




} // namespace
