#include "chatchannel.h"
#include "../../application/base/application.h"

namespace DOMAIN
{
	IMPLEMENT_SERIALIZEABLE_DOMAIN(CChatChannel);

	CChatChannel::~CChatChannel()
	{
		SAFE_FREE(lastText);
	}

	void CChatChannel::HandleDomainObjectActionRequest(sptr<CDomainCommand> &cmd)
	{
		TDomainObjectAction1P1S *act = (TDomainObjectAction1P1S*)cmd->GetParam();
		switch (act->action)
		{
		case 101: // SAY
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);
				if (ISOFTYPE(go,DOMAIN::CGraphObject))
					ActionSay((sptr<CGraphObject>)go,act->text, true);
			}
			break;
		}
	}

	void CChatChannel::HandleDomainObjectActionReply(sptr<CDomainCommand> &cmd)
	{
		TDomainObjectAction1P1S *act = (TDomainObjectAction1P1S*)cmd->GetParam();
		switch (act->action)
		{
		case 101: // SAY
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);
				if (ISOFTYPE(go,DOMAIN::CGraphObject))
					ActionSay((sptr<CGraphObject>)go,act->text, false);
			}
			break;
		}
	}

	void CChatChannel::GetActionList(tActionList &_actions, int witch)
	{
	}

	//int CChatChannel::ExecuteAction(int _actionId, int lparam, void *pparam)
	int CChatChannel::ExecuteAction(int _actionId,  CGraphObject *_caller, long lParam, void *pParam)
	{
		switch (_actionId)
		{
		case 101: // SAY

			TDomainObjectAction1P1S *act = new TDomainObjectAction1P1S(_actionId, GetID(), lParam,(char*)pParam);

			CGameObject::InitiateAction(act,sizeof(TDomainObjectAction1P1S));
			return 0;
		}
		return 0;
	}



	int CChatChannel::ActionSay(sptr<CGraphObject> &_caller, char *_text, bool isRequest)
	{
		// do chat update if reply
		// else distribute

		if (!isRequest)
		{
			//SAFE_FREE(lastText); ///@ todo: creates memory leaks
			lastText = strdup(_text);
			UpdateRenderables(FRONTEND::UPDATEFLAGS_ALL);

			//parent->ActionChatReply(&_caller,0, _text);

		} 
		else
		{
			sptr<CDomainCommand> cmd = sptr<CDomainCommand>(new CDomainCommand(domain));
			cmd->SetCommand(DOMAINCMD_OBJECTACTION_REPLY);
			cmd->SetParamLen(sizeof(TDomainObjectAction1P1S));
			TDomainObjectAction1P1S *act = new TDomainObjectAction1P1S(CONFIG::g_config.ObjectActions["CHAT_SAY"],GetID(),_caller->GetID(),_text);
			cmd->SetParam(act);
			cmd->SetSendToClientList(sendToClients);

			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,sendToClients);
		}


		return 0;
	}

	int CChatChannel::ActionJoin(sptr<CGraphObject> &_caller, bool isRequest)
	{
		return 0;
	}

	int CChatChannel::ActionLeave(sptr<CGraphObject> &_caller, bool isRequest)
	{
		return 0;
	}




}