#ifndef DOMAIN_CHATCHANNEL_H
#define DOMAIN_CHATCHANNEL_H

#include "../../general/base/serialize.h"
#include "../base/domain.h"
#include "../base/objectman.h"

#include "../implementation/domaincommand.h"
#include "objects.h"

namespace DOMAIN
{
	class CChatChannel : public CGraphObject
	{
	public:
		DECLARE_SERIALIZEABLE(CChatChannel);

	protected:

		char *lastText;
		/// @todo: could be buggy if more than 1 line is inserted during a timeslice

	public:

		inline CChatChannel(CDomain *_domain)
			  : CGraphObject(_domain)
		{
			SetClassKey(GET_KEY(CChatChannel));
			lastText = 0;
		}

		inline CChatChannel(CDomain *_domain, int _odid,long _id, long _parentId) 
			: CGraphObject(_domain,_odid,_id)
		{
			SetClassKey(GET_KEY(CChatChannel));
			parentId = _parentId;
			lastText = 0;
		}

		virtual ~CChatChannel();

		virtual void HandleDomainObjectActionRequest(sptr<CDomainCommand> &cmd);		
		virtual void HandleDomainObjectActionReply(sptr<CDomainCommand> &cmd);		

		virtual void GetActionList(tActionList &_actions, int witch=-1);
	//	virtual int ExecuteAction(int _actionId, int lparam, void *pparam);
		virtual int ExecuteAction(int _actionId, CGraphObject *_caller, long lParam = 0, void *pParam = 0);


		virtual int ActionSay(sptr<CGraphObject> &_caller, char *_text, bool isRequest);
		virtual int ActionJoin(sptr<CGraphObject> &_caller, bool isRequest);
		virtual int ActionLeave(sptr<CGraphObject> &_caller, bool isRequest);
		inline char *GetLastText() { return lastText;};

	};
}

#endif