#include "domainlight.h"


namespace DOMAIN
{
	IMPLEMENT_SERIALIZEABLE_DOMAIN(CLight);

	long CLight::GetSerializedSize()
	{
		return 
			CLevelObject::GetSerializedSize() +
			3*sizeof(GENERAL::CVector4f),
			5*sizeof(float);
	}

	long CLight::Serialize(GENERAL::CBuffer &buffer)
	{
		CLevelObject::Serialize(buffer);
		GENERAL::SerializeVector4f(ambientColor,buffer);
		GENERAL::SerializeVector4f(diffuseColor,buffer);
		GENERAL::SerializeVector4f(specularColor,buffer);
		buffer.Write(&spotExponent,sizeof(float));
		buffer.Write(&spotCutoff,sizeof(float));
		buffer.Write(&constantAtt,sizeof(float));
		buffer.Write(&linearAtt,sizeof(float));
		buffer.Write(&quadAtt,sizeof(float));
		return buffer.GetPos();
	}

	long CLight::DeSerialize(GENERAL::CBuffer &buffer)
	{
		CLevelObject::DeSerialize(buffer);
		GENERAL::DeSerializeVector4f(ambientColor,buffer);
		GENERAL::DeSerializeVector4f(diffuseColor,buffer);
		GENERAL::DeSerializeVector4f(specularColor,buffer);
		spotExponent =*(float*)buffer.Read(sizeof(float));
		spotCutoff =*(float*)buffer.Read(sizeof(float));
		constantAtt =*(float*)buffer.Read(sizeof(float));
		linearAtt =*(float*)buffer.Read(sizeof(float));
		quadAtt =*(float*)buffer.Read(sizeof(float));
		return buffer.GetPos();
	}

}