#ifndef FRONTEND_H
#define FRONTEND_H

#include <string>
#include <map>
#include <list>

#include "../../general/morfgeneral.h"
#include "../../domain/base/domain.h"
#include "renderable.h"
#include "resource.h"

namespace FRONTEND
{
	enum EUIType {
		UITYPE_UNKNOWN=0,
		UITYPE_ICONCONTAINER=1,
		UITYPE_CHATWINDOW=2,
		UITYPE_FSMINFO=3

	};
	class CResourceManager
	{
	public:
		typedef std::map<std::string, HFEResource> TNameToPtrMap; 

	protected:

		TNameToPtrMap resMap;
	
	public:
		CResourceManager();
		virtual ~CResourceManager() = 0;

		virtual HFEResource GetPtr(sptr<CRenderAble> &_renderable, char *_resName, EResTyp _typ = RESTYP_AUTO) = 0;
		virtual HFEResource CreateRes(char *_resName, EResTyp _typ = RESTYP_AUTO) = 0;

	};
	

	class CFrontEnd
	{
	protected:

		CResourceManager *resMan;

	public:
		virtual void SpiderDied();

		inline CFrontEnd() { };
		virtual ~CFrontEnd();

		virtual bool Init() = 0;
		
		virtual void Render(DOMAIN::CDomain::TObjectList *_obj) = 0;
		//virtual CRenderAble *CreateObject(DOMAIN::CGraphObject *_from) = 0;
		virtual sptr<CRenderAble> CreateObject(DOMAIN::CGraphObject *_from, int _typ, int iParam=0, void *pParam=NULL) = 0;


		virtual void CreateUIObject(DOMAIN::CGraphObject *_from, int _uitype, int lParam = 0, void *pParam = 0) = 0;
		virtual void SetCamera(sptr<DOMAIN::CWorldObject> _obj) = 0;


		// interfaces fr Buenutzereingaben
		virtual void KeyDown(int key,TKeyStates &keystate) = 0;
		virtual void KeyUp(int key,TKeyStates &keystate) = 0;
		virtual void KeyPress(int key,TKeyStates &keystate) = 0;
		virtual void MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys) = 0;
		virtual void MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys) = 0;
		virtual void MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys) = 0;
		virtual void MouseClick(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys) = 0;
		virtual void Resize(INT x, INT y) = 0;

		virtual void SelectionChanged(DOMAIN::CGameObject *_old, DOMAIN::CGameObject *_new);



	};
}
#endif