#ifndef RENDERABLE_H
#define RENDERABLE_H

#include "../../general/morfgeneral.h"
#include "frontendtypes.h"
#include "resource.h"


namespace DOMAIN
{
	class CGraphObject;
}

namespace FRONTEND
{
	class CFrontEnd;

	enum EUpdateFlags { UPDATEFLAGS_ALL=0 };
	enum ERenderSelectMode 
	{ 
		RENDERSELECT_NONE=0,
		RENDERSELECT_NORMAL=1,
		RENDERSELECT_DETAIL=2,
	};

	class CRenderAble
	{
	public:
//		std::vector<sptr<CRenderAble> > TRenderAbleList;
		static CRenderAble *selectedRenderAble;
	protected:

		void *fe;
		DOMAIN::CGraphObject *domainObj;
        int time;

		ERenderSelectMode selectMode;
		int selectName;
		int isSelected;

	public:

		inline CRenderAble(void *_fe ,DOMAIN::CGraphObject *_domainObj) : domainObj(_domainObj), time(0), fe(_fe), selectName(RENDERSELECT_NONE), isSelected(false) {};
		virtual void Init(sptr<CRenderAble> &_self);

		virtual ~CRenderAble();

		virtual void Update(int _flags = UPDATEFLAGS_ALL);
		virtual void Render(int _dt = 0);

		virtual bool MouseMove(int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseDown(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseUp(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys);
		virtual bool MouseClick(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys);
		virtual void Select();
		virtual void Deselect();

		inline void *GetFe() { return fe; };

		inline DOMAIN::CGraphObject *GetDomainObj() { return domainObj; };
		inline void SetDomainObj(DOMAIN::CGraphObject *_obj) { domainObj=_obj; Update(); };
		inline int GetSelectName() {return selectName;};
		virtual void SetSelectMode(ERenderSelectMode _mode, int defaultName);

		virtual void ResourceLoaded(CFEResource *_res);

	};
}

#endif