#ifndef RESOURCE_H
#define RESOURCE_H

#include <string>
#include <map>
#include <list>
#include <queue>

#include "../../general/morfgeneral.h"

namespace FRONTEND
{
	class CResourceManager;
	class CRenderAble;

	typedef enum EResTyp {		RESTYP_AUTO=0,
								RESTYP_TEXTURE=1,
								RESTYP_TTFONT=2,
								RESTYP_BMPFONT=3,
								RESTYP_STYLE=4,
								RESTYP_SHADER=5,
								RESTYP_MD3LINK=6,
								RESTYP_FSM=7,
								RESTYP_GUISTYLE=8,
						};
	
	typedef enum EResStatus {	RESSTATUS_NOTLOADED=0,
								RESSTATUS_INMEMORY=1,
								RESSTATUS_INMEMORYANDGA=2,
								RESSTATUS_ONLYINGA=3};

	


	class CFEResource
	{
	public:
		typedef std::queue<sptr<CRenderAble> > TRenderAbleRefList;
	protected:
		
		long ref;
		char *fname;

		CResourceManager *resMan;
		TRenderAbleRefList renderAbleRefList;

		int status;

	public:

		CFEResource(CResourceManager *_resMan,char *_file, int _targetstatus); 
		
		virtual ~CFEResource();

		//inline long GetResId()		{ return resId; };

		inline int GetRefCount()	{ return ref; };
		inline int GetStatus()		{ return status; };
		inline CResourceManager* GetResourceManager() {return resMan;};

		long ReleaseRef();
		
		virtual bool LoadFromFile(char *_file, int _targetstatus) = 0;
		virtual bool LoadIntoGraphicAdapter(int _targetsatus) = 0;
		virtual bool UnloadFromGraphicAdapter() = 0;

		void AddRenderableRef(sptr<CRenderAble> &_renderable);
		void CallResourceLoaded();

	};

	typedef sptr<CFEResource> HFEResource;

}

#endif