#include "objectdescriptor.h"

#include <vector>

#include "../general/base/morftools.h"

namespace GAME
{
	CObjectDescriptor::~CObjectDescriptor() {}

	bool CObjectDescriptor::LoadFromFile(char *_name, char *_filename)
	{

		int level = 0;
		FILE *fp = GENERAL::morfOpenFile(_filename,"r");
		char line[1024],*token,*curprop,*curkey;

		std::vector<std::string> tokens;

		while (fgets(line,1024,fp)!=NULL)
		{
			token = strtok(line," \n\t");
			while (token)
			{
				tokens.push_back(token);
				token = strtok(NULL," \n\t");
			}
		}

		bool inDescriptor=false;
		bool key = true;

		curprop = 0;
		curkey = 0;

		for (std::vector<std::string>::iterator it = tokens.begin(); it!=tokens.end(); it++)
		{
			if (!stricmp("{",it->data()))
			{
				level++;
				continue;
			}
			if (!stricmp("}",it->data()))
			{
				level--;
				continue;
			}

			if (level==0) 
			{
				char *num = strtok((char*)it->data(),":");
				if (num==NULL) continue;

				char *name = strtok(NULL,"");
				if (name==NULL) continue;

				if (!stricmp(_name,name))
				{
					inDescriptor=true;
					continue;
				} else {
					inDescriptor=false;
					continue;
				}
			} else {
				if (!inDescriptor)
				{
					continue;
				} else {
					if (level==1)
					{
						curprop = (char*)it->data();
					} else {

						if (key)
						{
							curkey=(char*)it->data();
							key=false;
						} else 
						{
							
							if (curprop && curkey) 
							{
								properties[curprop][curkey]=TObjectProperty((char*)(*it).data());
								key=true;
							}
							else
							{
								GENERAL::dprintf("should not be reached!\n");
							}
						}
					}
				}
			}
		}

		if (ferror(fp))
		{
			fclose(fp);
			return false;
		}

		fclose(fp);
		return true;
	}
        
	bool CObjectDescriptor::Init(char *_name, char *_filename)
	{
		return LoadFromFile(_name,_filename);
	}

}