#include "levelobjects.h"
#include "../implementation/domainquakebsp.h"

namespace DOMAIN
{
	IMPLEMENT_SERIALIZEABLE(DOMAIN::CLevelObject);
	IMPLEMENT_SERIALIZEABLE(DOMAIN::CPhysicalLevelObject);
	IMPLEMENT_SERIALIZEABLE(DOMAIN::CLevel) 
	
	CLevel::~CLevel()
	{
	}

	CLevelObject::~CLevelObject() 
	{
	}

	void CLevelObject::SetLvl(CLevel *_lvl) 
	{
		lvl = _lvl; 
	};

/*	void CLevelObject::Assign(CGameObject *o)
	{
		
		CWorldObject::Assign(o);
		lvlId = ((CLevelObject*)o)->GetLvlId();
		lvl = 0;
	}*/
	
	long CLevelObject::GetSerializedSize()
	{
		return 
			CWorldObject::GetSerializedSize()+
			sizeof(long) ;
	}
	
	long CLevelObject::Serialize(GENERAL::CBuffer &buffer)
	{
		CWorldObject::Serialize(buffer);
		
		buffer.Write(&lvlId,sizeof(long));

		return buffer.GetPos();

	}
	
	long CLevelObject::DeSerialize(GENERAL::CBuffer &buffer)
	{
		CWorldObject::DeSerialize(buffer);

		lvlId =*(long*)buffer.Read(sizeof(long));

		return buffer.GetPos();
	}

	/***************** P H Y S I C A L 
	                     L E V E L
	                     O B J E C T  ****************************************/ 

	
	CPhysicalLevelObject::~CPhysicalLevelObject() 
	{
	}

	long CPhysicalLevelObject::GetSerializedSize()
	{
		return 
			CLevelObject::GetSerializedSize()+
			(sizeof(int) * 2) +  // collissionMode & movmentMode 
			(sizeof(float)*3) +  // mass, boundingRadius, stepHeight
			(GENERAL::GetSerializedSizeVector3f()*2);  // velocity, anglevelocity
	}

	long CPhysicalLevelObject::Serialize(GENERAL::CBuffer &buffer)
	{
		CLevelObject::Serialize(buffer);

		buffer.Write(&mass,sizeof(float));
		buffer.Write(&boundingRadius,sizeof(float));
		buffer.Write(&stepHeight,sizeof(float));
		buffer.Write(&collisionMode, sizeof(int));
		buffer.Write(&movementMode, sizeof(int));
		GENERAL::SerializeVector3f(velocity[ACT],buffer);
		GENERAL::SerializeVector3f(anglevelocity,buffer);


		return buffer.GetPos();
	}

	long CPhysicalLevelObject::DeSerialize(GENERAL::CBuffer &buffer)
	{
		CLevelObject::DeSerialize(buffer);

		mass =*(float*)buffer.Read(sizeof(float));
		boundingRadius =*(float*)buffer.Read(sizeof(float));
		stepHeight =*(float*)buffer.Read(sizeof(float));

		collisionMode =*(int*)buffer.Read(sizeof(int));
		movementMode =*(int*)buffer.Read(sizeof(int));
		
		GENERAL::DeSerializeVector3f(velocity[ACT],buffer);
		GENERAL::DeSerializeVector3f(anglevelocity,buffer);

		return buffer.GetPos();
	}

	void CPhysicalLevelObject::CopyPDUto(char *data)
	{
		CLevelObject::CopyPDUto(data);
		TPDU *pdu = (TPDU*)data;
		pdu->velocity = velocity[PDU];
	}


	void CPhysicalLevelObject::CopyPDUfrom(char *data)
	{
		CLevelObject::CopyPDUfrom(data);
		TPDU *pdu = (TPDU*)data;
		velocity[PDU]=pdu->velocity;
	}

	void CPhysicalLevelObject::SetPDU()
	{
		CLevelObject::SetPDU();
		velocity[PDU]=velocity[ACT];
	}

	int CPhysicalLevelObject::GetPDUSize()
	{
		return sizeof(TPDU);
	}

	void CPhysicalLevelObject::Print(FILE *f,bool newline)
	{
		CLevelObject::Print(f,newline);
	}

/*	void CPhysicalLevelObject::Assign(CGameObject *o)
	{
		CLevelObject::Assign(o);

		stepHeight = ((CPhysicalLevelObject*)o)->GetStepHeight();
		movementMode = ((CPhysicalLevelObject*)o)->GetMovementMode();
		collisionMode = ((CPhysicalLevelObject*)o)->GetCollisionMode();
		mass = ((CPhysicalLevelObject*)o)->GetMass();						
		boundingRadius = ((CPhysicalLevelObject*)o)->GetBoundingRadius();			
	}*/

	void CPhysicalLevelObject::TimeStep(GENERAL::TGameTick dt)
	{

		if (!lvl) return;

		CLevelObject::TimeStep(dt);

		GENERAL::CVector3f newpos;
		
		newpos = pos[PDU] + velocity[PDU]*((float)dt)/1000.0f;
		
//		pos[PDU]= ((CQuakeBsp*)GetLvl())->Trace(this,pos[PDU], newpos);

		if (doDeathReckoning)
		{

//			pos = CWorldObject::pdu.pos;
//			rotation = pdu.;

			pos[ACT] = pos[PDU];
			rotation[ACT] = rotation[PDU];
			velocity[ACT] = velocity[PDU];

/*			newpos = pos[PDU] + velocity[PDU]*((float)dt)/1000.0f;
			CWorldObject::GetPDU().pos = ((CQuakeBsp*)GetLvl())->TraceSphere(this,CWorldObject::GetPDU().pos, newpos);

			if (GetPDUTreshHold()>1.0f)
			{
				pos = CWorldObject::GetPDU().pos;
			}*/
		} else {
			// controlling
/*			newpos=CWorldObject::GetPDU().pos+pdu.velocity*((float)dt)/1000.0f;
			CWorldObject::GetPDU().pos=((CQuakeBsp*)GetLvl())->TraceSphere(this,CWorldObject::GetPDU().pos, newpos);

			newpos=pos+velocity*((float)dt)/1000.0f;
			pos = ((CQuakeBsp*)GetLvl())->TraceSphere(this,pos, newpos);*/


			newpos = pos[ACT] + velocity[ACT]*((float)dt)/1000.0f;
			
			pos[ACT]= ((CQuakeBsp*)GetLvl())->Trace(this,pos[ACT], newpos);

		


		}
	}

	void CPhysicalLevelObject::MoveTo(GENERAL::CVector3f &_pos)
	{
		pos[ACT] = _pos;
	}
	
	

	void CPhysicalLevelObject::Forward(float amount)
	
	{
		/*
		if (GetLvl()==0)
		{
			pos += rotation*amount;
		}
		else
		{
			pos = ((CQuakeBsp*)GetLvl())->TraceSphere(this,pos, pos+(rotation*amount));
		}
		*/
		

	}


	void CPhysicalLevelObject::LookX(float angle)
	{
		static float currentRotUp = 0.0f;
			currentRotUp +=angle;

		if ((currentRotUp>-1.0f) && (currentRotUp<1.0f))
			{
				GENERAL::CMatrix4f mat;
				GENERAL::CVector3f axis(rotation[ACT] * GENERAL::CVector3f(0.0f,1.0f,0.0f));

				axis.Normal();
				mat.SetRotate(angle,axis);
				rotation[ACT] = mat * rotation[ACT];
				rotation[ACT].Normal();
			}
	}

	void CPhysicalLevelObject::LookY(float angle)
	{
		GENERAL::CMatrix4f mat;
		mat.SetRotate(angle,GENERAL::CVector3f(0.0f,1.0f,0.0f));
		rotation[ACT] = mat * rotation[ACT];
		rotation[ACT].Normal();
	}

	void CPhysicalLevelObject::LookZ(float angle)
	{
	}

	


	

}
