#include "characterobject.h"
#include "characterobject.h"
#include <trace.h>

namespace DOMAIN
{
	IMPLEMENT_SERIALIZEABLE_DOMAIN(DOMAIN::CCharacterObject);

	CCharacterObject::~CCharacterObject() {};

	bool CCharacterObject::Load()
	{
		fsm->Init("data/fsm/character.state2");
		inventory->Load();
		return CMD3Object::Load();
	}


	long CCharacterObject::GetSerializedSize()
	{
		return CMD3Object::GetSerializedSize();
	}

	long CCharacterObject::Serialize(GENERAL::CBuffer &buffer)
	{
		CMD3Object::Serialize(buffer);
		return buffer.GetPos();
	}

	long CCharacterObject::DeSerialize(GENERAL::CBuffer &buffer)
	{
		CMD3Object::DeSerialize(buffer);
		return buffer.GetPos();
	}

	void CCharacterObject::Print(FILE *f,bool newline)
	{
		CMD3Object::Print(f,newline);
	}

	ECollisionAction CCharacterObject::Collided(CVector3f pos, CVector3f normal)
	{
		if (GetID()>=10000)
		{
			if (health>0)
			{
				if (normal.y<0.2)
				{
					LookY(newdir>0?1.0f:-1.0f);
					SetVelocity(GetRotation()*100);
				}
			}
		}

		return CMD3Object::Collided(pos,normal);
	}

	void CCharacterObject::TimeStep(GENERAL::TGameTick dt)
	{
		if (IsControled())
		{
			if (GetID()>=10000)
			{
				if (GetHealth()>0)
				{
					TGameTick gt = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();

					if (until>gt)
					{
						LookY(newdir>0?0.1:-0.1);
						SetVelocity(GetRotation()*80.0f);
						feCommands.push(4); // WALK
						SetFSMState(4);
					} else {
						if (rand()%64<1)
						{
							newdir = rand()%2;
							until = gt+rand()%2000;
						}
					}
				}
				else 
				{
//					SetControl();
					SetVelocity(CVector3f(0.0f,0.0f,0.0f));
					SetRotation(CVector3f(0.0f,0.0f,1.0f));
					until = 0;
				}
			}
		} 

		CMD3Object::TimeStep(dt);

		if ((nextUse!=-1)&&(nextUse < timestamp[ACT]))// APPLICATION::CApplication::GetApplication()->GetTicker().getTick()))
			ActionUse(sptr<CGraphObject>(NULL),false);

		/*
		if (stats->GetKiType()!=0)
		{
			// no player
			LookY(0.01);
		
		}
		else
		{

		}
		*/
		


	}

	int CCharacterObject::AddLink(sptr<DOMAIN::CMD3Object> &_obj)
	{
		for (int kk=0; kk<1; kk++)
		{
			sptr<FRONTEND::CRenderAble> ra(NULL);
			if (APPLICATION::CApplication::GetApplication()->GetFE())
			{
				ra=APPLICATION::CApplication::GetApplication()->GetFE()->CreateObject(&_obj,_obj->GetTargetLink(),_obj->GetTargetTag());
			}

			if (!inventory->HasChild(_obj))
			{
				inventory->AddChild(_obj);
			}

			std::vector<tLink> &tagLinks=links[_obj->GetTargetTag()];

			while (!tagLinks.empty())
			{
				if (tagLinks.back().object != NULL)
				{
					tagLinks.back().object->SetParent(&inventory);
					tagLinks.back().object->SetContainerType(CONFIG::g_config.ObjectStatus["INCONTAINER"]);

				}
				tagLinks.pop_back();
			}

			tagLinks.push_back(tLink(_obj->GetTargetLink(),ra,_obj));
			_obj->feCommands.push(fsmState[ACT]);
			feCommands.push(fsmState[ACT]);
			_obj->SetParent(this);
/*			if (_obj->GetTargetTag()==1)
				SetfeData(ra);*/

			_obj->SetContainerType(CONFIG::g_config.ObjectStatus["EQUIPPED"]);
		}
		return 0;



/*		if (_obj==NULL)
			return -1;

		if (!links[_obj->GetTargetTag()].empty())
		{
			if (links[_obj->GetTargetTag()].front().object != 0)
			{
				links[_obj->GetTargetTag()].front().object->SetContainerType(CONFIG::g_config.ObjectStatus["INCONTAINER"]);
				links[_obj->GetTargetTag()].front().object->SetParent(&inventory);
			}
			links[_obj->GetTargetTag()].clear();
		}

		int res;
		if ((res=CMD3Object::AddLink(_obj))!=0) return res;

		_obj->SetParent(this);

		return 0;*/
	}
	
	int CCharacterObject::RemoveLink(int _tag, int _id)
	{
		return CMD3Object::RemoveLink(_tag,_id);
	}

	void CCharacterObject::HandleDomainObjectActionRequest(sptr<CDomainCommand> &cmd)
	{
		TDomainObjectAction1P *act = (TDomainObjectAction1P*)cmd->GetParam();
		switch (act->action)
		{
		case 1:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);
				if (ISOFTYPE(go,DOMAIN::CGraphObject))
					ActionTake((sptr<CGraphObject>)go,true);
			}
			break;
		case 2:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);
				if (ISOFTYPE(go,DOMAIN::CGraphObject))
					ActionDrop((sptr<CGraphObject>)go,true);
			}
			break;
		case 3:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);
				if (ISOFTYPE(go,DOMAIN::CGraphObject))
					ActionEquip((sptr<CGraphObject>)go,true);
			}
			break;
		case 5:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);
				if (ISOFTYPE(go,DOMAIN::CGraphObject))
				{
					nextUse = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
					ActionUse((sptr<CGraphObject>)go,true);
				}
			}
			break;
		}
	}

	void CCharacterObject::HandleDomainObjectActionReply(sptr<CDomainCommand> &cmd)
	{
		TDomainObjectAction1P *act = (TDomainObjectAction1P*)cmd->GetParam();
		switch (act->action)
		{
		case 1:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);
				if (ISOFTYPE(go,DOMAIN::CGraphObject))
					ActionTake((sptr<CGraphObject>)go,false);
			}
			break;
		case 2:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);

				if (go==NULL)
				{
					domain->RequestObjects(1,&act->destObj,cmd);
				} 
				else 
				{
					if (ISOFTYPE(go,DOMAIN::CGraphObject))
						ActionDrop((sptr<CGraphObject>)go,false);
				}
			}
			break;
		case 3:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);

				if (go==NULL)
				{
					domain->RequestObjects(1,&act->destObj,cmd);
				} 
				else 
				{
					if (ISOFTYPE(go,DOMAIN::CGraphObject))
						ActionEquip((sptr<CGraphObject>)go,false);
				}
			}
			break;
		case 4:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);

				if (go==NULL)
				{
					domain->GetObjMan()->Add(cmd);
					sptr<CDomainCommand> request = sptr<CDomainCommand>(new CDomainCommand(domain));
					request->SetCommand(DOMAINCMD_REQUEST_OBJECT);
					request->SetParamLen(sizeof(long));
					request->SetParam(new long(act->destObj));
					request->SetUserdata(&cmd);
					domain->GetObjMan()->Add(request);
					cmd->SetSendToClientList(cmd->GetSendToClientList());
					APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,cmd->GetSendToClientList());
				}

				if (ISOFTYPE(go,DOMAIN::CGraphObject))
					ActionEquip((sptr<CGraphObject>)go,false);
			}
			break;	
		case 5:
			{
				sptr<CGameObject> &go=domain->GetObjMan()->GetPtr(act->destObj);

				if (go==NULL)
				{
					domain->RequestObjects(1,&act->destObj,cmd);
				} 
				else 
				{
					if (ISOFTYPE(go,DOMAIN::CGraphObject))
					{
						nextUse = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
						ActionUse((sptr<CGraphObject>)go,false);
					}
				}
			}
			break;	
		}
	}


	int CCharacterObject::ExecuteAction(int _actionId,  CGraphObject *_caller, long lParam, void *pParam)
	{
//		InitiateAction(TAKE)
		switch (_actionId)
		{
			/// @todo make case dynamic
		case 1: InitiateAction(new TDomainObjectAction1P(1, GetID(), _caller->GetID()),sizeof(TDomainObjectAction1P));
				return 0;
		case 2: InitiateAction(new TDomainObjectAction1P(2, GetID(), _caller->GetID()),sizeof(TDomainObjectAction1P));
				return 0;
		case 3: InitiateAction(new TDomainObjectAction1P(3, GetID(), _caller->GetID()),sizeof(TDomainObjectAction1P));
				return 0;
		case 5:	
			if (selectedGameObject!=NULL)
				InitiateAction(new TDomainObjectAction1P(5, GetID(), selectedGameObject->GetID()),sizeof(TDomainObjectAction1P)); 
//		case 5:	InitiateAction(new TDomainObjectAction1P(5, GetID(), _caller->GetID()),sizeof(TDomainObjectAction1P)); 
//			ActionUse(_caller,false);
				return 0;
		case 6: return ActionOpenInventory(inventory, false);
		case 8:	// talk
			{
				//((APPLICATION::CApplication*)APPLICATION::CApplication::GetApplication())
				//	->GetFE()->CreateUIObject(this,FRONTEND::UITYPE_CHATWINDOW);
				long cid = _caller->GetOwnedChatChannel();
				if (cid!=0)				
				{
					DOMAIN::CGameObject *ghj = &domain->GetObjMan()->GetPtr(cid);
					APPLICATION::CApplication::GetApplication()->GetFE()->CreateUIObject((DOMAIN::CGraphObject*) ghj,FRONTEND::UITYPE_CHATWINDOW);
				}
				else
				{
					dprintf("(Open Owned Chatwindow): 0 Channel ID");
				}
				return 0;
			}
		case 101: // talk
			{
				_caller->ExecuteAction(101,_caller,GetID(),pParam);
			}
		case 102: // new message in owned channel
		{
			//ActionChatReply(_caller, (char*)pParam);
		}


			break;
		default: 
			{
				dprintf("[ WARN ] CCharacterObject::ExecuteAction: unknown ActionId: %i\n",_actionId);
				return -1;
			}
		}
		return 0;
	}

	///////////////////////////////////////////
	///// ACTIONS ///////////
	////////////////
	/////////
	/////
	///
	//
	void CCharacterObject::GetActionList(tActionList &_actions, int witch)
	{

		if (odid==0)
		{
			tActionList all;
			std::map<std::string, long>::iterator it;
			for (it = CONFIG::g_config.ObjectActions.begin(); it != CONFIG::g_config.ObjectActions.end(); it++)
			{
				all.push_back(it->second);
			}

			if (witch==0)
			{
				_actions = all;
				return;
			};

			tChildsType::iterator cit;

			tActionList inventoryActions;
			inventory->GetActionList(inventoryActions);
			for (cit=inventory->GetChilds().begin(); cit !=inventory->GetChilds().end(); cit++)
			{
				tActionList itemActions;
				(*cit)->GetActionList(itemActions);
				inventoryActions = inventoryActions | itemActions;
			}

			_actions = all & inventoryActions;
		}
		else
		{
			CMD3Object::GetActionList(_actions);
			return;
		}
	}

	int CCharacterObject::ActionTake(sptr<CGraphObject> &_caller, bool isRequest)
	{	
		((CLevelObject*)&_caller)->GetLvl()->RemoveChild(_caller);
//		_caller->GetParent()->RemoveChild(_caller);
		inventory->AddChild(_caller);
		_caller->SetContainerType(CONFIG::g_config.ObjectStatus["INCONTAINER"]);

		if (isRequest)
		{
			sptr<CDomainCommand> cmd = sptr<CDomainCommand>(new CDomainCommand(domain));
			cmd->SetCommand(DOMAINCMD_OBJECTACTION_REPLY);
			cmd->SetParamLen(sizeof(TDomainObjectAction1P));
			TDomainObjectAction1P *act = new TDomainObjectAction1P(CONFIG::g_config.ObjectActions["TAKE"],GetID(),_caller->GetID());
			cmd->SetParam(act);
			cmd->SetSendToClientList(sendToClients);

			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,sendToClients);
		}
/*		if (reply)
		{

			sptr<CDomainCommand> dc = sptr<CDomainCommand>(new CDomainCommand(domain));
			dc->SetCommand(DOMAINCMD_OBJECTACTION_REPLY);
			
			dc->SetParamLen(sizeof(long)*3);

			TDomainObjectAction1P *act = new TDomainObjectAction1P(CONFIG::g_config.ObjectActions["TAKE"],GetID(),_caller->GetID());
			dc->SetParam(act);
			dc->SetSendToClientList(NULL);

			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(dc,sendToClients);
		} 
		else
		{
			sptr<CDomainCommand> dc = sptr<CDomainCommand>(new CDomainCommand(domain));
			dc->SetCommand(DOMAINCMD_OBJECTACTION_REQUEST);
			
			dc->SetParamLen(sizeof(long)*3);

			TDomainObjectAction1P *act = new TDomainObjectAction1P(CONFIG::g_config.ObjectActions["TAKE"],GetID(),_caller->GetID());
			dc->SetParam(act);
			dc->SetSendToClientList(NULL);

			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(dc,sendToClients);
		}*/
	
		return 0;
	}

	int CCharacterObject::ActionDrop(sptr<CGraphObject> &_caller, bool isRequest)
	{
		inventory->RemoveChild(_caller);
		((CWorldObject*)&_caller)->SetPos(GetPos());
		GetLvl()->AddChild(_caller);
		_caller->SetContainerType(CONFIG::g_config.ObjectStatus["INWORLD"]);

		if (isRequest)
		{
			sptr<CDomainCommand> cmd = sptr<CDomainCommand>(new CDomainCommand(domain));
			cmd->SetCommand(DOMAINCMD_OBJECTACTION_REPLY);
			cmd->SetParamLen(sizeof(TDomainObjectAction1P));
			TDomainObjectAction1P *act = new TDomainObjectAction1P(CONFIG::g_config.ObjectActions["DROP"],GetID(),_caller->GetID());
			cmd->SetParam(act);
			cmd->SetSendToClientList(sendToClients);

			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,sendToClients);
		}

		return 0;
	}

	int CCharacterObject::ActionEquip(sptr<CGraphObject> &_caller, bool isRequest)
	{
		if (ISOFTYPE(_caller,CMD3Object))
		{
			AddChild(_caller);

			if (isRequest)
			{
				sptr<CDomainCommand> cmd = sptr<CDomainCommand>(new CDomainCommand(domain));
				cmd->SetCommand(DOMAINCMD_OBJECTACTION_REPLY);
				cmd->SetParamLen(sizeof(TDomainObjectAction1P));
				TDomainObjectAction1P *act = new TDomainObjectAction1P(CONFIG::g_config.ObjectActions["EQUIP"],GetID(),_caller->GetID());
				cmd->SetParam(act);
				cmd->SetSendToClientList(sendToClients);

				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,sendToClients);
			}
		}

		if (isRequest)
		{
			sptr<CDomainCommand> cmd = sptr<CDomainCommand>(new CDomainCommand(domain));
			cmd->SetCommand(DOMAINCMD_OBJECTACTION_REPLY);
			cmd->SetParamLen(sizeof(TDomainObjectAction1P));
			TDomainObjectAction1P *act = new TDomainObjectAction1P(CONFIG::g_config.ObjectActions["EQUIP"],GetID(),_caller->GetID());
			cmd->SetParam(act);
			cmd->SetSendToClientList(sendToClients);

			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,sendToClients);
		}
		return 0;
	}

	int CCharacterObject::ActionOpenInventory(sptr<CGraphObject> &_caller, bool isRequest)
	{
		((APPLICATION::CApplication*)APPLICATION::CApplication::GetApplication())
			->GetFE()->CreateUIObject(&GetInventory(),FRONTEND::UITYPE_ICONCONTAINER);
		return 0;
	}
	
	int CCharacterObject::ActionUse(sptr<CGraphObject> &_caller, bool isRequest)
	{
		if (isRequest)
		{
			sptr<CDomainCommand> cmd = sptr<CDomainCommand>(new CDomainCommand(domain));
			cmd->SetCommand(DOMAINCMD_OBJECTACTION_REPLY);
			cmd->SetParamLen(sizeof(TDomainObjectAction1P));
			TDomainObjectAction1P *act = new TDomainObjectAction1P(CONFIG::g_config.ObjectActions["USE"],GetID(),_caller->GetID());
			cmd->SetParam(act);
			cmd->SetSendToClientList(sendToClients);

			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,sendToClients);
		} 
//		else 
		{
			if (_caller!=NULL)
				useTarget = (sptr<CWorldObject>)_caller;

			tLinkMap::iterator weaponLink = links.find(5);
			if (weaponLink!=links.end())
			{
				if (!weaponLink->second.empty())
				{
					if (weaponLink->second.front().object!=NULL)
					{
						weaponLink->second.front().object->ActionUse(useTarget);
					}
				} 
			}
	
/*			if (dir.ScalarMultiply(GetRotation())<0.9f)
			{
				nextUse+=100;
			}
			else
			{
				CVector3f srot;
				srot.x  = (((SCALAR)(rand()&0xff))-128.0f) / 50.0f;
				srot.y  = (((SCALAR)(rand()&0xff))-128.0f) / 50.0f;
				srot.z  = (((SCALAR)(rand()&0xff))-128.0f) / 50.0f;

				sptr<DOMAIN::CShot> shot(new DOMAIN::CShot(domain,useTarget,250,0,GetLvl(),GetPos(),srot,CVector3f(1.0f,1.0f,1.0f),0.0f,0.0f,TBox(),dir));
				shot->SetMovementMode(MOVEMENTMODE_FLOATING);
				shot->SetCollisionMode(COLLISIONMODE_SPHERE);
				GetLvl()->AddChild(shot);
				shot->AddLink(1,-250); // rootnode 
				shot->SetControl();
				shot->SetVelocity(shot->GetVelocity()*1000.0f);
				domain->GetObjMan()->Add(shot);

				CVector3f displace(0.0f,20.0f,0.0f);
				displace+=dir*10.0f;
				displace+=shot->GetPos();
				shot->MoveTo(GetLvl()->Trace(this,shot->GetPos(), displace));
				GetLvl()->LevelObjectMoved(&shot);

				feCommands.push(5);
				nextUse+=250;
			}*/
		}

		return true;
	}

	int CCharacterObject::ActionChatReply(CGraphObject *_caller, long _whoId, char *_msg)
	{
		return 0;
	}
	

	


	void CCharacterObject::ActionHit(int damage)
	{
		if (health)
		{
			health-=damage;
			if (health<=0)
			{
				health=0;
				feCommands.push(1);

				DOMAIN::CDomainCommand *doc=new DOMAIN::CDomainCommand(domain);
				doc->SetCommand(DOMAINCMD_KILLED);
				doc->SetID(GetID());
				doc->SetParamLen(sizeof(long));
				char *data = (char*)malloc(sizeof(long));
				memcpy(data,&id,sizeof(id));
				doc->SetParam(data);
				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(doc,GetSendToClientList());

				GetBoundingBox().minV.y -= 5;
				MoveTo(GetPos()+CVector3f(0.0f,6.0f,0.0f));

				if (APPLICATION::CApplication::GetApplication()->GetFE())
					APPLICATION::CApplication::GetApplication()->GetFE()->SpiderDied();
			}
		}
		UpdateRenderables(1);
	}


}
