#include "testobject.h"

#include <trace.h>

namespace DOMAIN {
	IMPLEMENT_SERIALIZEABLE_DOMAIN(CTestObject);

	CTestObject::CTestObject(CDomain *_domain) 
		: CWorldObject(_domain), 
		  x(0.0f),y(0.0f),r(0.0f),
		  angle(0.0f),
		  speed(0.0f)
	{
		SetClassKey(GET_KEY(CTestObject));
	}
	CTestObject::CTestObject(CDomain *_domain, int _odid,long _id)
		: CWorldObject(_domain,_odid,_id),
		  x(0.0f),y(0.0f),r(0.0f),
		  angle(0.0f),
		  speed(0.0f)
	{
		SetClassKey(GET_KEY(CTestObject));
	}

	CTestObject::~CTestObject()
	{
	}

	long CTestObject::GetSerializedSize()
	{
		return CWorldObject::GetSerializedSize()+
			sizeof(x)+sizeof(y)+sizeof(r)+sizeof(speed)+sizeof(angle);
	}

	long CTestObject::Serialize(GENERAL::CBuffer &buffer)
	{
		CWorldObject::Serialize(buffer);
		buffer.Write(&x,sizeof(x));
		buffer.Write(&y,sizeof(y));
		buffer.Write(&r,sizeof(r));
		buffer.Write(&speed,sizeof(speed));
		buffer.Write(&angle,sizeof(angle));
		return buffer.GetPos();
	}

	long CTestObject::DeSerialize(GENERAL::CBuffer &buffer)
	{
		CWorldObject::DeSerialize(buffer);
		x=*(float*)buffer.Read(sizeof(x));
		y=*(float*)buffer.Read(sizeof(y));
		r=*(float*)buffer.Read(sizeof(r));
		speed=*(float*)buffer.Read(sizeof(speed));
		angle=*(float*)buffer.Read(sizeof(angle));
		return buffer.GetPos();
	}

	void CTestObject::Print(FILE *f,bool newline)
	{
		CWorldObject::Print(f,false);
		fprintf(f,", (x,y): (%f,%f)",x,y);
		if (newline) fprintf(f,"\n");
	}

/*	void CTestObject::Assign(CGameObject *o)
	{
		CWorldObject::Assign(o);
		x=((CTestObject*)o)->x;
		y=((CTestObject*)o)->y;
		r=((CTestObject*)o)->r;
		speed=((CTestObject*)o)->speed;
		angle=((CTestObject*)o)->angle;
	}*/

	void CTestObject::TimeStep(GENERAL::TGameTick dt)
	{
		CWorldObject::TimeStep(dt);
		angle+=((float)(((double)dt)*speed));
		if (angle>2*3.14159265358979) angle-=2*3.14159265358979f;
		if (angle<0) angle+=2*3.14159265358979f;

	}

}