#ifndef GAME_PLAYERSTATS_H
#define GAME_PLAYERSTATS_H

#include <map>
#include <string>

#include <morfbase.h>

namespace DOMAIN
{
	class CCharacterObject;
}

namespace GAME
{
	
	const PRIMARY = 0;
	const SECONDARY = 1;

	const ACT = 0;
	const MAX = 1;
	const MOD = 2;	

	typedef enum 
	{
		HOSTILITY_HOSTILE = 0,
		HOSTILITY_NEUTRAL = 1,
		HOSTILITY_FRIENDLY = 2

	} eHostility;



	class CPlayerStats
	{
	protected:

		int classId[2];
		int hitpoints[3];

		int kiType; // 0=Player

		int baseHostility;
		typedef std::map<long, int> TStandingMap;
		TStandingMap standings;

		DOMAIN::CCharacterObject *owner;

	public:

		CPlayerStats(DOMAIN::CCharacterObject *_owner, int _priClass, int _secClass, int _baseHost, int _hpMax, int hpAct);

		virtual ~CPlayerStats();

		inline int GetBaseHostility() { return baseHostility; };
		inline void SetStanding(long _Id, int _hostility = 1) { standings[_Id] = _hostility; };

		int GetHostility(long _Id);

		inline int GetHitPoints(int _which) { return hitpoints[_which]; };
		inline void SetHitPOints(int _which, int val) { hitpoints[_which] = val; };

		inline int GetClassId(int _which) { return  classId[_which]; };
		std::string GetClassString();
		inline void SetClassId(int _which, int _val) { classId[_which]=_val; };

		inline int GetKiType() { return kiType; };
		inline void SetKiType(int t) { kiType=t; };


       
	};
}

#endif
