#ifndef OBJECTDOMAIN_H
#define OBJECTDOMAIN_H
#include <list>
#include <map>
#include <string>

/*
#include "../../_general/base/morfforward.h"
#include "../../_general/base/morfmodules.h"

#include "../implementation/testobject.h"
#include "../implementation/logindata.h"
#include "../implementation/chatdomain.h"
#include "../../_domain/base/objectman.h"
*/

#include <morfclasses.h>


//#include "../../_application/base/application.h"



namespace DOMAIN 
{
	typedef struct _TUserInfo
	{
		NETWORK::PClientInfoList sendToUserList;
		bool isAuth;
		bool hasReceivedAllData;
		sptr<CCharacterObject> controllingObject;
		char *username;

		int lastpingNum;
		GENERAL::TGameTick pingtime[16];
		GENERAL::TGameTick avgpingtime;
		GENERAL::TGameTick nextping;
	} TUserInfo;

	typedef std::map<NETWORK::CClientInfo*, TUserInfo*> TUserInfoList;

	class CObjectDomain : public CChatDomain
	{
	protected:
		TUserInfoList userInfoList;
		NETWORK::TClientInfoList &allUsers;

		virtual void PushGameObject(sptr<CGameObject> &go, NETWORK::PClientInfoList sendTo);
		virtual void PushAllTo(NETWORK::PClientInfoList sendTo);
		virtual void PushLevelTo(sptr<CLevel> &lvl, NETWORK::PClientInfoList sendTo);
		virtual sptr<CGameObject> CreateUserObject(TUserInfo *ui);

		virtual void AddFoe(int odId, CVector3f pos);
	public:
		inline CObjectDomain() 
			: CChatDomain(true),
			  allUsers(*(new NETWORK::TClientInfoList()))
		{};

		virtual ~CObjectDomain();
		virtual void handleDomainCommand(sptr<CDomainCommand> cmd);
		virtual void handleNetworkObject(sptr<GENERAL::CSerializeableObject> &so);

		virtual void execute();

		virtual void Init();

		virtual void SynchTime(TUserInfo &ui);
		virtual void Ping(TUserInfo &ui);
	};



}

#endif