// gameserver.cpp : Defines the entry point for the console application.
//
#include <tchar.h>
#include <signal.h>

//#include "foreign/simpleoptions.h"
#include <morfbase.h>


#include "domain/implementation/serverobjectdomain.h"


#include <trace.h>


bool doTerminate=false;

using namespace DOMAIN;
using namespace APPLICATION;
using namespace NETWORK;

void _cdecl SigHandler(int signal)
{
	CApplication::GetApplication()->GetDomain()->Terminate();
}

void Usage(char *filename)
{
	fprintf(stdout,"Usage: %s\n"); 
	exit(1);
}

class CGameserver : public CApplication
{
private:
	CInputThread *it;

public:
	CGameserver(int argc, _TCHAR* argv[]) 
		: CApplication()
	{
		if (argc>1) Usage(argv[0]);

/*		CSimpleOptions options(argc,argv,"scu:p:",1);
		try 
		{
			while (options.next())
			{
				switch(options.option())
				{
				case 'c':
					if (server!=-1) Usage(argv[0]);
					server=0;
					break;
				case 's':
					if (server!=-1) Usage(argv[0]);
					server=1;
					break;
				case 'u':
					if (name!=NULL) Usage(argv[0]);
					name=(char*)options.arg();
					break;
				case 'p':
					if (pass!=NULL) Usage(argv[0]);
					pass=(char*)options.arg();
					break;
				}
			}
		}
		catch ( const SIMPLE_OPTIONS_EXCEPTION & )
		{
			Usage(argv[0]);
		}

		if ((name==NULL) || (server==-1))
			Usage(argv[0]);

		isServer=(server==1);
		if (pass==NULL) pass="";*/
	}
	virtual ~CGameserver()
	{
		SAFE_DELETE(it)
		if (GetNetwork()) delete GetNetwork();
		if (GetDomain()) delete GetDomain();
	}

	virtual bool Init()
	{
		bool res = CApplication::Init();

		signal(SIGINT,SigHandler);
		signal(SIGTERM,SigHandler);


		//SetObjectMan(new CSimpleObjectManager(this));
		//SetDomain(new CChatDomain(true));
		SetDomain(new CObjectDomain());

		GetDomain()->Init();


	//	SetGameDB(new GAMEDB::CGameDatabaseMySQL());
		SetNetwork(new NETWORK::CTCPNetwork(GetDomain(),true));

		fprintf(stdout,"Chatserver using CChatDomain\n");
		fprintf(stdout,"============================\n");

		it = new CInputThread();

		return res;
	}

	virtual void ExecuteSlice()
	{
		GetNetwork()->Lock();
		while (!it->IsEpmty())
		{
			char *input = it->PopString();
			if (strncmp(input,"/shutdown",8)==0)
			{
				doTerminate=true;
				delete [] input;
				break;
			}
			//fprintf(stdout,"input: %s",input);
			delete [] input;
		}
		GetDomain()->execute();
//		Sleep(50);

		GetNetwork()->Unlock();
	}

	virtual void Render()
	{
	}

	void RegisterClasses()
	{
		GENERAL::RegisterClasses();
		CApplication::RegisterClasses();
	//	REGISTER_SERIALIZEABLE(DOMAIN::CTestObject,100,GENERAL::CGameObject);
	}

};

int _tmain(int argc, _TCHAR* argv[])
{
	InitTrace();

	HANDLE hProcess;

	hProcess = GetCurrentProcess();
	int res = SetPriorityClass(hProcess,HIGH_PRIORITY_CLASS);

	try
	{
		CApplication::SetApplication(new CGameserver(argc,argv));
		CApplication::GetApplication()->Init();
		CApplication::GetApplication()->Run();
		delete CApplication::GetApplication();
	}
	catch (exception e)
	{
		fprintf(stderr,"%s\n",e.what());
		fflush(stderr);
	}

	res = SetPriorityClass(hProcess,NORMAL_PRIORITY_CLASS);

	fprintf(stdout,"Server terminated\n");
	fflush(stdout);
	DoneTrace();
	return 0;
}


