#include <windows.h>
#include <tchar.h>
#include <morfbase.h>
#include <stdio.h>

#include <map>

typedef std::map<int,GENERAL::CParser::TNode::TChildren::iterator> TWinMap;
TWinMap windows;

void findWindows(char *_name,GENERAL::CParser::TNode *node)
{
	char *eptr;
	GENERAL::CParser::TNode::TChildren::iterator it;
	GENERAL::CParser::TNode *winnode;

	char *name=_name;

	it = node->children.find("name");
	if (it!=node->children.end())
	{
		name = it->second->val;
	}

	for (it=node->children.begin(); it != node->children.end(); it++)
	{
		if (it->second->val==NULL)
		{
			winnode=it->second;
			long id = strtol(winnode->children.find("id")->second->val,&eptr,0);

			if (strncmp(it->first.data(),"CCTL",4)==0)
			{
				windows[id] = it;
				if (name!=0)
				{
					GENERAL::CParser::TNode *namenode = new GENERAL::CParser::TNode(name);
					winnode->children.insert(
						GENERAL::CParser::TNode::TChildren::value_type("__parent__",namenode));
				}
				findWindows(name,winnode);
			} else {
				char newname[128];
				if (name==NULL)
					sprintf(newname,"%s",it->first.data());
				else
					sprintf(newname,"%s.%s",name,it->first.data());
				
				windows[id] = it;
				findWindows(newname,winnode);
			}

			
		}
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	GENERAL::CParser parser;
	parser.LoadFromFile(argc>=2?argv[1]:"data/dialog1.txt");

	GENERAL::CParser::TNode *config = parser.GetRoot()->children.find("config")->second;
	GENERAL::CParser::TNode *dialog = parser.GetRoot()->children.find("dialog")->second;

	windows.clear();
	findWindows(NULL,dialog);


	char *outfile;
	if (argc>2)
		outfile=strdup(argv[2]);
	else
		outfile=strdup("data/dialog1.h");

	if (argc==2)
	{
		outfile = strdup(argv[1]);
		outfile[strlen(outfile)-3]='h';
		outfile[strlen(outfile)-2]='\0';
	}
	FILE *f=(argc>=2)?fopen(outfile,"w"):stdout;
	if (argc==2)
		free(outfile);


	char *classname = config->children.find("classname")->second->val;
	char *father = (char*)dialog->children.begin()->first.data();

	fprintf(f,
		"/*****************************************/\n"
		"/* this file was generated by CTL_Header */\n"
		"/* modifications may be discarded!!      */\n"
		"/*****************************************/\n");
	fprintf(f,"#ifndef __%s\n",classname);
	fprintf(f,"#define __%s\n\n",classname);
	fprintf(f,"#include %s\n\n",config->children.find("include")->second->val);
	fprintf(f,"namespace FRONTEND\n");
	fprintf(f,"{\n");
	fprintf(f,"\tclass %s : public CCTLDialog\n",classname);
	fprintf(f,"\t{\n");
	fprintf(f,"\tpublic:\n");
	
	TWinMap::iterator it;

	for (it=windows.begin(); it!=windows.end(); it++)
	{
		char *name=NULL;
		char *cname;

		GENERAL::CParser::TNode::TChildren::iterator cit;
		cit = it->second->second->children.find("name");
		if (cit!=it->second->second->children.end())
			name = cit->second->val;
		cname = (char*)it->second->first.data();

		if (name) fprintf(f,"\t\t%s %s;\n",cname,name);
	}

	fprintf(f,"\n\tpublic:\n");
	fprintf(f,"\t\tinline %s(DOMAIN::CGraphObject *_domainObj, CResStyle *_style)\n",classname);
	fprintf(f,"\t\t\t: CCTLDialog(_domainObj,_style)");
	for (it=windows.begin(); it!=windows.end(); it++)
	{
		char *name=NULL;
		GENERAL::CParser::TNode::TChildren::iterator cit;
		cit = it->second->second->children.find("name");
		if (cit!=it->second->second->children.end())
			name = cit->second->val;
		if (name!=NULL)
			fprintf(f,",\n\t\t\t  %s(_domainObj,_style,userdata,staticCallBack)",name);
	}
	fprintf(f,"\n\t\t{};\n");
	fprintf(f,"\n\t\tvirtual void Init();\n");
	fprintf(f,"\n");
	fprintf(f,"\t};\n");
	fprintf(f,"} // namespace\n\n");
	fprintf(f,"#endif \n");

	fclose(f);
/// End HeaderFile

	f=fopen(argv[3],"w");

	fprintf(f,
		"/*****************************************/\n"
		"/* this file was generated by CTL_Header */\n"
		"/* modifications may be discarded!!      */\n"
		"/*****************************************/\n");
	fprintf(f,"#include \"%s\"\n\n",argv[2]);
	fprintf(f,"void FRONTEND::%s::Init()\n{\n",classname);
	fprintf(f,"\tCCTLDialog::Init();\n");
	char *border=NULL;
	char *pos;
	char *id;
	pos = dialog->children.find("pos")->second->val;
	id = dialog->children.find("id")->second->val;
	GENERAL::CParser::TNode::TChildren::iterator cit;
		
	fprintf(f,"\tSetID(%s);\n",id);
	cit = dialog->children.find("bordersize");
	if (cit!=dialog->children.end())
		fprintf(f,"\tSetBorderSize%s;\n",cit->second->val);
	fprintf(f,"\tSetPos%s;\n",pos);


	for (it=windows.begin(); it!=windows.end(); it++)
	{
		char *parent=NULL;
		char *name=NULL;
		char *style=NULL;
		cit = it->second->second->children.find("name");
		if (cit!=it->second->second->children.end())
			name = cit->second->val;
		else
			name = (char*)it->second->first.data();
		
		cit = it->second->second->children.find("pos");
		if (cit!=it->second->second->children.end())
			pos = cit->second->val;
		else
			pos=NULL;

		cit = it->second->second->children.find("style");
		if (cit!=it->second->second->children.end())
			style = cit->second->val;
		else
			style=NULL;

		id = it->second->second->children.find("id")->second->val;

		cit = it->second->second->children.find("__parent__");
		if (cit!=it->second->second->children.end())
		{
			parent=cit->second->val;
		}

		if (strncmp(it->second->first.data(),"CCTL",4)==0)
		{
			fprintf(f,"\t%s.Init();\n",name);
		}

//		SplitPos(pos,xl,xr,yu,yl);

		fprintf(f,"\t%s.SetID(%s);\n",name,id);


		cit = it->second->second->children.find("bordersize");
		if (cit!=it->second->second->children.end())
			fprintf(f,"\t%s.SetBorderSize%s;\n",name,cit->second->val);

		if (pos) fprintf(f,"\t%s.SetPos%s;\n",name,pos);
		if (style) fprintf(f,"\t%s.SetStyleElement(\"%s\");\n",name,style);

		if (strcmp(it->second->first.data(),"CCTLLabel")==0)
		{
			char *text;
			text = it->second->second->children.find("text")->second->val;
			fprintf(f,"\t%s.SetText(\"%s\");\n",name,text);
		} else
		if (strcmp(it->second->first.data(),"CCTLEdit")==0)
		{
			cit = it->second->second->children.find("text");
			if (cit!=it->second->second->children.end())
				fprintf(f,"\t%s.SetText(\"%s\");\n",name,cit->second->val);
		} else
		if (strcmp(it->second->first.data(),"CCTLClientWindow")==0)
		{
			GENERAL::CParser::TNode *node = it->second->second->children.find("client")->second;
			id = node->children.find("id")->second->val;
			pos = node->children.find("pos")->second->val;

			fprintf(f,"\t%s.GetClient()->SetID(%s);\n",name,id);
			fprintf(f,"\t%s.GetClient()->SetPos%s;\n",name,pos);
		}

		if (parent!=NULL)
		{
			fprintf(f,"\t%s.InsertControl(&%s);\n",parent,name);
		} else {
		//	fprintf(f,"\tInsertControl(&%s);\n",name);
		}

	};
	fprintf(f,"}\n");


	//CCTLWindow(DOMAIN::CGraphObject *_domainObj, CResStyle *_style
	
	argc>=2?fclose(f):fgetc(stdin);


	return 0;
}
